!******************************************************************************!
!                                                                              !
!    class_couplings.f90                                                       !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   class_couplings.f90                            |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 11/2018                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2020-07-30 18:23             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module class_couplings
  use constants_mdl
  use class_particles
  implicit none
  save
  integer, parameter :: n = 183

  logical :: couplings_init = .false.
  logical :: ctcouplings_init = .false.
  complex(dp) :: coupl(1281)
  integer, parameter :: nGC_89 = 1
  integer, parameter :: nGC_5134 = 2
  integer, parameter :: nGC_5137 = 3
  integer, parameter :: nGC_5131 = 4
  integer, parameter :: nGC_5133 = 5
  integer, parameter :: nGC_5132 = 6
  integer, parameter :: nGC_5158 = 7
  integer, parameter :: nGC_5139 = 8
  integer, parameter :: nGC_5440 = 9
  integer, parameter :: nGC_5443 = 10
  integer, parameter :: nGC_5442 = 11
  integer, parameter :: nGC_5445 = 12
  integer, parameter :: nGC_5444 = 13
  integer, parameter :: nGC_5446 = 14
  integer, parameter :: nGC_5449 = 15
  integer, parameter :: nGC_5395 = 16
  integer, parameter :: nGC_I = 17
  integer, parameter :: nGC_5424 = 18
  integer, parameter :: nGC_5148 = 19
  integer, parameter :: nGC_5390 = 20
  integer, parameter :: nGC_5135 = 21
  integer, parameter :: nGC_5136 = 22
  integer, parameter :: nGC_83 = 23
  integer, parameter :: nGC_5130 = 24
  integer, parameter :: nGC_5312 = 25
  integer, parameter :: nGC_5295 = 26
  integer, parameter :: nGC_5347 = 27
  integer, parameter :: nGC_5344 = 28
  integer, parameter :: nGC_5345 = 29
  integer, parameter :: nGC_5229 = 30
  integer, parameter :: nGC_5341 = 31
  integer, parameter :: nGC_5224 = 32
  integer, parameter :: nGC_5227 = 33
  integer, parameter :: nGC_5226 = 34
  integer, parameter :: nGC_5221 = 35
  integer, parameter :: nGC_5220 = 36
  integer, parameter :: nGC_5223 = 37
  integer, parameter :: nGC_5222 = 38
  integer, parameter :: nGC_30 = 39
  integer, parameter :: nGC_5138 = 40
  integer, parameter :: nGC_101 = 41
  integer, parameter :: nGC_MC = 42
  integer, parameter :: nGC_MZ_GF = 43
  integer, parameter :: nGC_98 = 44
  integer, parameter :: nGC_5253 = 45
  integer, parameter :: nGC_102 = 46
  integer, parameter :: nGC_28 = 47
  integer, parameter :: nGC_29 = 48
  integer, parameter :: nGC_96 = 49
  integer, parameter :: nGC_22 = 50
  integer, parameter :: nGC_23 = 51
  integer, parameter :: nGC_20 = 52
  integer, parameter :: nGC_21 = 53
  integer, parameter :: nGC_26 = 54
  integer, parameter :: nGC_27 = 55
  integer, parameter :: nGC_24 = 56
  integer, parameter :: nGC_25 = 57
  integer, parameter :: nGC_153 = 58
  integer, parameter :: nGC_152 = 59
  integer, parameter :: nGC_151 = 60
  integer, parameter :: nGC_150 = 61
  integer, parameter :: nGC_157 = 62
  integer, parameter :: nGC_156 = 63
  integer, parameter :: nGC_155 = 64
  integer, parameter :: nGC_154 = 65
  integer, parameter :: nGC_93 = 66
  integer, parameter :: nGC_159 = 67
  integer, parameter :: nGC_158 = 68
  integer, parameter :: nGC_5239 = 69
  integer, parameter :: nGC_91 = 70
  integer, parameter :: nGC_5335 = 71
  integer, parameter :: nGC_5190 = 72
  integer, parameter :: nGC_5362 = 73
  integer, parameter :: nGC_5263 = 74
  integer, parameter :: nGC_148 = 75
  integer, parameter :: nGC_MWp = 76
  integer, parameter :: nGC_5230 = 77
  integer, parameter :: nGC_5405 = 78
  integer, parameter :: nGC_5404 = 79
  integer, parameter :: nGC_5407 = 80
  integer, parameter :: nGC_5231 = 81
  integer, parameter :: nGC_5401 = 82
  integer, parameter :: nGC_5402 = 83
  integer, parameter :: nGC_5408 = 84
  integer, parameter :: nGC_5237 = 85
  integer, parameter :: nGC_126 = 86
  integer, parameter :: nGC_127 = 87
  integer, parameter :: nGC_125 = 88
  integer, parameter :: nGC_122 = 89
  integer, parameter :: nGC_123 = 90
  integer, parameter :: nGC_120 = 91
  integer, parameter :: nGC_128 = 92
  integer, parameter :: nGC_129 = 93
  integer, parameter :: nGC_1917 = 94
  integer, parameter :: nGC_5281 = 95
  integer, parameter :: nGC_100 = 96
  integer, parameter :: nGC_5044 = 97
  integer, parameter :: nGC_5046 = 98
  integer, parameter :: nGC_MMW_GF = 99
  integer, parameter :: nGC_5049 = 100
  integer, parameter :: nGC_5048 = 101
  integer, parameter :: nGC_5167 = 102
  integer, parameter :: nGC_5164 = 103
  integer, parameter :: nGC_5165 = 104
  integer, parameter :: nGC_5161 = 105
  integer, parameter :: nGC_5261 = 106
  integer, parameter :: nGC_70 = 107
  integer, parameter :: nGC_5309 = 108
  integer, parameter :: nGC_5303 = 109
  integer, parameter :: nGC_5301 = 110
  integer, parameter :: nGC_5307 = 111
  integer, parameter :: nGC_5304 = 112
  integer, parameter :: nGC_5305 = 113
  integer, parameter :: nGC_69 = 114
  integer, parameter :: nGC_109 = 115
  integer, parameter :: nGC_140 = 116
  integer, parameter :: nGC_65 = 117
  integer, parameter :: nGC_5384 = 118
  integer, parameter :: nGC_7562 = 119
  integer, parameter :: nGC_5262 = 120
  integer, parameter :: nGC_5277 = 121
  integer, parameter :: nGC_5275 = 122
  integer, parameter :: nGC_5273 = 123
  integer, parameter :: nGC_5271 = 124
  integer, parameter :: nGC_5278 = 125
  integer, parameter :: nGC_5279 = 126
  integer, parameter :: nGC_3 = 127
  integer, parameter :: nGC_2 = 128
  integer, parameter :: nGC_1 = 129
  integer, parameter :: nGC_5433 = 130
  integer, parameter :: nGC_7 = 131
  integer, parameter :: nGC_6 = 132
  integer, parameter :: nGC_5 = 133
  integer, parameter :: nGC_4 = 134
  integer, parameter :: nGC_5377 = 135
  integer, parameter :: nGC_9 = 136
  integer, parameter :: nGC_8 = 137
  integer, parameter :: nGC_5372 = 138
  integer, parameter :: nGC_5371 = 139
  integer, parameter :: nGC_5282 = 140
  integer, parameter :: nGC_15 = 141
  integer, parameter :: nGC_53 = 142
  integer, parameter :: nGC_52 = 143
  integer, parameter :: nGC_51 = 144
  integer, parameter :: nGC_50 = 145
  integer, parameter :: nGC_57 = 146
  integer, parameter :: nGC_56 = 147
  integer, parameter :: nGC_55 = 148
  integer, parameter :: nGC_54 = 149
  integer, parameter :: nGC_59 = 150
  integer, parameter :: nGC_58 = 151
  integer, parameter :: nGC_12 = 152
  integer, parameter :: nGC_5289 = 153
  integer, parameter :: nGC_517 = 154
  integer, parameter :: nGC_8142 = 155
  integer, parameter :: nGC_MB = 156
  integer, parameter :: nGC_162 = 157
  integer, parameter :: nGC_163 = 158
  integer, parameter :: nGC_160 = 159
  integer, parameter :: nGC_161 = 160
  integer, parameter :: nGC_5287 = 161
  integer, parameter :: nGC_5285 = 162
  integer, parameter :: nGC_5280 = 163
  integer, parameter :: nGC_7956 = 164
  integer, parameter :: nGC_106 = 165
  integer, parameter :: nGC_MZp = 166
  integer, parameter :: nGC_107 = 167
  integer, parameter :: nGC_5389 = 168
  integer, parameter :: nGC_5088 = 169
  integer, parameter :: nGC_5121 = 170
  integer, parameter :: nGC_5127 = 171
  integer, parameter :: nGC_5124 = 172
  integer, parameter :: nGC_5080 = 173
  integer, parameter :: nGC_5128 = 174
  integer, parameter :: nGC_5129 = 175
  integer, parameter :: nGC_5084 = 176
  integer, parameter :: nGC_5086 = 177
  integer, parameter :: nGC_MZ = 178
  integer, parameter :: nGC_5458 = 179
  integer, parameter :: nGC_5459 = 180
  integer, parameter :: nGC_5456 = 181
  integer, parameter :: nGC_5457 = 182
  integer, parameter :: nGC_5454 = 183
  integer, parameter :: nGC_5455 = 184
  integer, parameter :: nGC_5452 = 185
  integer, parameter :: nGC_5453 = 186
  integer, parameter :: nGC_5451 = 187
  integer, parameter :: nGC_7872 = 188
  integer, parameter :: nGC_78 = 189
  integer, parameter :: nGC_5155 = 190
  integer, parameter :: nGC_5153 = 191
  integer, parameter :: nGC_5159 = 192
  integer, parameter :: nGC_7602 = 193
  integer, parameter :: nGC_5173 = 194
  integer, parameter :: nGC_5333 = 195
  integer, parameter :: nGC_5332 = 196
  integer, parameter :: nGC_5330 = 197
  integer, parameter :: nGC_5336 = 198
  integer, parameter :: nGC_5334 = 199
  integer, parameter :: nGC_5232 = 200
  integer, parameter :: nGC_5233 = 201
  integer, parameter :: nGC_5339 = 202
  integer, parameter :: nGC_5338 = 203
  integer, parameter :: nGC_5236 = 204
  integer, parameter :: nGC_5234 = 205
  integer, parameter :: nGC_5235 = 206
  integer, parameter :: nGC_5176 = 207
  integer, parameter :: nGC_5179 = 208
  integer, parameter :: nGC_5296 = 209
  integer, parameter :: nGC_8817 = 210
  integer, parameter :: nGC_5297 = 211
  integer, parameter :: nGC_16 = 212
  integer, parameter :: nGC_8585 = 213
  integer, parameter :: nGC_14 = 214
  integer, parameter :: nGC_13 = 215
  integer, parameter :: nGC_11 = 216
  integer, parameter :: nGC_10 = 217
  integer, parameter :: nGC_5243 = 218
  integer, parameter :: nGC_19 = 219
  integer, parameter :: nGC_18 = 220
  integer, parameter :: nGC_5241 = 221
  integer, parameter :: nGC_7655 = 222
  integer, parameter :: nGC_5240 = 223
  integer, parameter :: nGC_MW_GF = 224
  integer, parameter :: nGC_5247 = 225
  integer, parameter :: nGC_5245 = 226
  integer, parameter :: nGC_5244 = 227
  integer, parameter :: nGC_7898 = 228
  integer, parameter :: nGC_5242 = 229
  integer, parameter :: nGC_8064 = 230
  integer, parameter :: nGC_8061 = 231
  integer, parameter :: nGC_417 = 232
  integer, parameter :: nGC_97 = 233
  integer, parameter :: nGC_7606 = 234
  integer, parameter :: nGC_5413 = 235
  integer, parameter :: nGC_5410 = 236
  integer, parameter :: nGC_5411 = 237
  integer, parameter :: nGC_5416 = 238
  integer, parameter :: nGC_5414 = 239
  integer, parameter :: nGC_5415 = 240
  integer, parameter :: nGC_5378 = 241
  integer, parameter :: nGC_7629 = 242
  integer, parameter :: nGC_135 = 243
  integer, parameter :: nGC_134 = 244
  integer, parameter :: nGC_4826 = 245
  integer, parameter :: nGC_4820 = 246
  integer, parameter :: nGC_133 = 247
  integer, parameter :: nGC_132 = 248
  integer, parameter :: nGC_4940 = 249
  integer, parameter :: nGC_5375 = 250
  integer, parameter :: nGC_4945 = 251
  integer, parameter :: nGC_84 = 252
  integer, parameter :: nGC_5374 = 253
  integer, parameter :: nGC_5259 = 254
  integer, parameter :: nGC_5104 = 255
  integer, parameter :: nGC_647 = 256
  integer, parameter :: nGC_5052 = 257
  integer, parameter :: nGC_5053 = 258
  integer, parameter :: nGC_5050 = 259
  integer, parameter :: nGC_5051 = 260
  integer, parameter :: nGC_5054 = 261
  integer, parameter :: nGC_5058 = 262
  integer, parameter :: nGC_5059 = 263
  integer, parameter :: nGC_5118 = 264
  integer, parameter :: nGC_5110 = 265
  integer, parameter :: nGC_5115 = 266
  integer, parameter :: nGC_5463 = 267
  integer, parameter :: nGC_5348 = 268
  integer, parameter :: nGC_5461 = 269
  integer, parameter :: nGC_5460 = 270
  integer, parameter :: nGC_5349 = 271
  integer, parameter :: nGC_103 = 272
  integer, parameter :: nGC_5269 = 273
  integer, parameter :: nGC_116 = 274
  integer, parameter :: nGC_8861 = 275
  integer, parameter :: nGC_7928 = 276
  integer, parameter :: nGC_7929 = 277
  integer, parameter :: nGC_7924 = 278
  integer, parameter :: nGC_7925 = 279
  integer, parameter :: nGC_223 = 280
  integer, parameter :: nGC_227 = 281
  integer, parameter :: nGC_8334 = 282
  integer, parameter :: nGC_8335 = 283
  integer, parameter :: nGC_5060 = 284
  integer, parameter :: nGC_7694 = 285
  integer, parameter :: nGC_7695 = 286
  integer, parameter :: nGC_5203 = 287
  integer, parameter :: nGC_5202 = 288
  integer, parameter :: nGC_5200 = 289
  integer, parameter :: nGC_5206 = 290
  integer, parameter :: nGC_5205 = 291
  integer, parameter :: nGC_5204 = 292
  integer, parameter :: nGC_5209 = 293
  integer, parameter :: nGC_5208 = 294
  integer, parameter :: nGC_5369 = 295
  integer, parameter :: nGC_5365 = 296
  integer, parameter :: nGC_5366 = 297
  integer, parameter :: nGC_5360 = 298
  integer, parameter :: nGC_4917 = 299
  integer, parameter :: nGC_5160 = 300
  integer, parameter :: nGC_12323 = 301
  integer, parameter :: nGC_5257 = 302
  integer, parameter :: nGC_7626 = 303
  integer, parameter :: nGC_1739 = 304
  integer, parameter :: nGC_119 = 305
  integer, parameter :: nGC_4850 = 306
  integer, parameter :: nGC_7624 = 307
  integer, parameter :: nGC_48 = 308
  integer, parameter :: nGC_49 = 309
  integer, parameter :: nGC_44 = 310
  integer, parameter :: nGC_45 = 311
  integer, parameter :: nGC_46 = 312
  integer, parameter :: nGC_47 = 313
  integer, parameter :: nGC_40 = 314
  integer, parameter :: nGC_41 = 315
  integer, parameter :: nGC_42 = 316
  integer, parameter :: nGC_43 = 317
  integer, parameter :: nGC_7747 = 318
  integer, parameter :: nGC_8154 = 319
  integer, parameter :: nGC_4869 = 320
  integer, parameter :: nGC_5251 = 321
  integer, parameter :: nGC_4863 = 322
  integer, parameter :: nGC_4867 = 323
  integer, parameter :: nGC_5095 = 324
  integer, parameter :: nGC_5092 = 325
  integer, parameter :: nGC_5093 = 326
  integer, parameter :: nGC_5090 = 327
  integer, parameter :: nGC_138 = 328
  integer, parameter :: nGC_9217 = 329
  integer, parameter :: nGC_4852 = 330
  integer, parameter :: nGC_5098 = 331
  integer, parameter :: nGC_5099 = 332
  integer, parameter :: nGC_141 = 333
  integer, parameter :: nGC_7526 = 334
  integer, parameter :: nGC_7527 = 335
  integer, parameter :: nGC_7529 = 336
  integer, parameter :: nGC_5380 = 337
  integer, parameter :: nGC_5368 = 338
  integer, parameter :: nGC_7805 = 339
  integer, parameter :: nGC_137 = 340
  integer, parameter :: nGC_4914 = 341
  integer, parameter :: nGC_4915 = 342
  integer, parameter :: nGC_4916 = 343
  integer, parameter :: nGC_136 = 344
  integer, parameter :: nGC_4913 = 345
  integer, parameter :: nGC_131 = 346
  integer, parameter :: nGC_9958 = 347
  integer, parameter :: nGC_4918 = 348
  integer, parameter :: nGC_5426 = 349
  integer, parameter :: nGC_5425 = 350
  integer, parameter :: nGC_130 = 351
  integer, parameter :: nGC_7966 = 352
  integer, parameter :: nGC_4973 = 353
  integer, parameter :: nGC_5091 = 354
  integer, parameter :: nGC_5267 = 355
  integer, parameter :: nGC_2831 = 356
  integer, parameter :: nGC_5184 = 357
  integer, parameter :: nGC_7752 = 358
  integer, parameter :: nGC_5145 = 359
  integer, parameter :: nGC_5069 = 360
  integer, parameter :: nGC_5140 = 361
  integer, parameter :: nGC_5143 = 362
  integer, parameter :: nGC_5063 = 363
  integer, parameter :: nGC_139 = 364
  integer, parameter :: nGC_5061 = 365
  integer, parameter :: nGC_5066 = 366
  integer, parameter :: nGC_61 = 367
  integer, parameter :: nGC_7646 = 368
  integer, parameter :: nGC_8128 = 369
  integer, parameter :: nGC_5314 = 370
  integer, parameter :: nGC_144 = 371
  integer, parameter :: nGC_MD = 372
  integer, parameter :: nGC_5430 = 373
  integer, parameter :: nGC_5320 = 374
  integer, parameter :: nGC_5321 = 375
  integer, parameter :: nGC_5322 = 376
  integer, parameter :: nGC_5323 = 377
  integer, parameter :: nGC_5324 = 378
  integer, parameter :: nGC_5325 = 379
  integer, parameter :: nGC_5326 = 380
  integer, parameter :: nGC_5327 = 381
  integer, parameter :: nGC_5328 = 382
  integer, parameter :: nGC_5329 = 383
  integer, parameter :: nGC_118 = 384
  integer, parameter :: nGC_4931 = 385
  integer, parameter :: nGC_5170 = 386
  integer, parameter :: nGC_4859 = 387
  integer, parameter :: nGC_5151 = 388
  integer, parameter :: nGC_4848 = 389
  integer, parameter :: nGC_8573 = 390
  integer, parameter :: nGC_8478 = 391
  integer, parameter :: nGC_4879 = 392
  integer, parameter :: nGC_4878 = 393
  integer, parameter :: nGC_4919 = 394
  integer, parameter :: nGC_8143 = 395
  integer, parameter :: nGC_87 = 396
  integer, parameter :: nGC_5210 = 397
  integer, parameter :: nGC_12635 = 398
  integer, parameter :: nGC_4873 = 399
  integer, parameter :: nGC_5141 = 400
  integer, parameter :: nGC_7708 = 401
  integer, parameter :: nGC_5396 = 402
  integer, parameter :: nGC_5391 = 403
  integer, parameter :: nGC_5393 = 404
  integer, parameter :: nGC_5392 = 405
  integer, parameter :: nGC_5254 = 406
  integer, parameter :: nGC_5255 = 407
  integer, parameter :: nGC_5256 = 408
  integer, parameter :: nGC_5399 = 409
  integer, parameter :: nGC_5398 = 410
  integer, parameter :: nGC_5252 = 411
  integer, parameter :: nGC_4876 = 412
  integer, parameter :: nGC_5367 = 413
  integer, parameter :: nGC_99 = 414
  integer, parameter :: nGC_8058 = 415
  integer, parameter :: nGC_95 = 416
  integer, parameter :: nGC_8114 = 417
  integer, parameter :: nGC_90 = 418
  integer, parameter :: nGC_5192 = 419
  integer, parameter :: nGC_5191 = 420
  integer, parameter :: nGC_5197 = 421
  integer, parameter :: nGC_5196 = 422
  integer, parameter :: nGC_5194 = 423
  integer, parameter :: nGC_5067 = 424
  integer, parameter :: nGC_92 = 425
  integer, parameter :: nGC_5198 = 426
  integer, parameter :: nGC_5071 = 427
  integer, parameter :: nGC_5149 = 428
  integer, parameter :: nGC_75 = 429
  integer, parameter :: nGC_74 = 430
  integer, parameter :: nGC_77 = 431
  integer, parameter :: nGC_76 = 432
  integer, parameter :: nGC_71 = 433
  integer, parameter :: nGC_73 = 434
  integer, parameter :: nGC_72 = 435
  integer, parameter :: nGC_7600 = 436
  integer, parameter :: nGC_5064 = 437
  integer, parameter :: nGC_79 = 438
  integer, parameter :: nGC_7635 = 439
  integer, parameter :: nGC_7631 = 440
  integer, parameter :: nGC_7632 = 441
  integer, parameter :: nGC_142 = 442
  integer, parameter :: nGC_8604 = 443
  integer, parameter :: nGC_8605 = 444
  integer, parameter :: nGC_104 = 445
  integer, parameter :: nGC_105 = 446
  integer, parameter :: nGC_85 = 447
  integer, parameter :: nGC_86 = 448
  integer, parameter :: nGC_17 = 449
  integer, parameter :: nGC_143 = 450
  integer, parameter :: nGC_4839 = 451
  integer, parameter :: nGC_9830 = 452
  integer, parameter :: nGC_5342 = 453
  integer, parameter :: nGC_4888 = 454
  integer, parameter :: nGC_4854 = 455
  integer, parameter :: nGC_7532 = 456
  integer, parameter :: nGC_5100 = 457
  integer, parameter :: nGC_5363 = 458
  integer, parameter :: nGC_5105 = 459
  integer, parameter :: nGC_5106 = 460
  integer, parameter :: nGC_7556 = 461
  integer, parameter :: nGC_4884 = 462
  integer, parameter :: nGC_5113 = 463
  integer, parameter :: nGC_5417 = 464
  integer, parameter :: nGC_108 = 465
  integer, parameter :: nGC_7850 = 466
  integer, parameter :: nGC_8214 = 467
  integer, parameter :: nGC_183 = 468
  integer, parameter :: nGC_5125 = 469
  integer, parameter :: nGC_5218 = 470
  integer, parameter :: nGC_5249 = 471
  integer, parameter :: nGC_5114 = 472
  integer, parameter :: nGC_5083 = 473
  integer, parameter :: nGC_219 = 474
  integer, parameter :: nGC_8302 = 475
  integer, parameter :: nGC_5381 = 476
  integer, parameter :: nGC_8518 = 477
  integer, parameter :: nGC_4920 = 478
  integer, parameter :: nGC_5462 = 479
  integer, parameter :: nGC_5077 = 480
  integer, parameter :: nGC_8949 = 481
  integer, parameter :: nGC_4883 = 482
  integer, parameter :: nGC_4890 = 483
  integer, parameter :: nGC_5211 = 484
  integer, parameter :: nGC_5212 = 485
  integer, parameter :: nGC_5213 = 486
  integer, parameter :: nGC_5214 = 487
  integer, parameter :: nGC_5215 = 488
  integer, parameter :: nGC_5216 = 489
  integer, parameter :: nGC_5217 = 490
  integer, parameter :: nGC_5219 = 491
  integer, parameter :: nGC_82 = 492
  integer, parameter :: nGC_5359 = 493
  integer, parameter :: nGC_4877 = 494
  integer, parameter :: nGC_4880 = 495
  integer, parameter :: nGC_5350 = 496
  integer, parameter :: nGC_5353 = 497
  integer, parameter :: nGC_5354 = 498
  integer, parameter :: nGC_5357 = 499
  integer, parameter :: nGC_9015 = 500
  integer, parameter :: nGC_5351 = 501
  integer, parameter :: nGC_287 = 502
  integer, parameter :: nGC_9586 = 503
  integer, parameter :: nGC_8834 = 504
  integer, parameter :: nGC_149 = 505
  integer, parameter :: nGC_5352 = 506
  integer, parameter :: nGC_4881 = 507
  integer, parameter :: nGC_5181 = 508
  integer, parameter :: nGC_661 = 509
  integer, parameter :: nGC_5298 = 510
  integer, parameter :: nGC_5182 = 511
  integer, parameter :: nGC_94 = 512
  integer, parameter :: nGC_39 = 513
  integer, parameter :: nGC_38 = 514
  integer, parameter :: nGC_5183 = 515
  integer, parameter :: nGC_9016 = 516
  integer, parameter :: nGC_31 = 517
  integer, parameter :: nGC_33 = 518
  integer, parameter :: nGC_5356 = 519
  integer, parameter :: nGC_35 = 520
  integer, parameter :: nGC_34 = 521
  integer, parameter :: nGC_37 = 522
  integer, parameter :: nGC_36 = 523
  integer, parameter :: nGC_4855 = 524
  integer, parameter :: nGC_4907 = 525
  integer, parameter :: nGC_4857 = 526
  integer, parameter :: nGC_147 = 527
  integer, parameter :: nGC_9300 = 528
  integer, parameter :: nGC_5299 = 529
  integer, parameter :: nGC_4997 = 530
  integer, parameter :: nGC_4990 = 531
  integer, parameter :: nGC_4991 = 532
  integer, parameter :: nGC_4992 = 533
  integer, parameter :: nGC_4993 = 534
  integer, parameter :: nGC_5265 = 535
  integer, parameter :: nGC_8837 = 536
  integer, parameter :: nGC_4902 = 537
  integer, parameter :: nGC_5101 = 538
  integer, parameter :: nGC_10073 = 539
  integer, parameter :: nGC_4901 = 540
  integer, parameter :: nGC_10071 = 541
  integer, parameter :: nGC_5264 = 542
  integer, parameter :: nGC_4900 = 543
  integer, parameter :: nGC_7781 = 544
  integer, parameter :: nGC_8477 = 545
  integer, parameter :: nGC_8018 = 546
  integer, parameter :: nGC_5428 = 547
  integer, parameter :: nGC_5439 = 548
  integer, parameter :: nGC_4921 = 549
  integer, parameter :: nGC_4922 = 550
  integer, parameter :: nGC_4925 = 551
  integer, parameter :: nGC_4924 = 552
  integer, parameter :: nGC_4927 = 553
  integer, parameter :: nGC_5122 = 554
  integer, parameter :: nGC_4928 = 555
  integer, parameter :: nGC_5434 = 556
  integer, parameter :: nGC_5435 = 557
  integer, parameter :: nGC_5436 = 558
  integer, parameter :: nGC_5437 = 559
  integer, parameter :: nGC_MI = 560
  integer, parameter :: nGC_MH = 561
  integer, parameter :: nGC_7959 = 562
  integer, parameter :: nGC_4868 = 563
  integer, parameter :: nGC_MM = 564
  integer, parameter :: nGC_5250 = 565
  integer, parameter :: nGC_ME = 566
  integer, parameter :: nGC_8606 = 567
  integer, parameter :: nGC_5315 = 568
  integer, parameter :: nGC_4856 = 569
  integer, parameter :: nGC_8265 = 570
  integer, parameter :: nGC_117 = 571
  integer, parameter :: nGC_5123 = 572
  integer, parameter :: nGC_10627 = 573
  integer, parameter :: nGC_MS = 574
  integer, parameter :: nGC_2829 = 575
  integer, parameter :: nGC_MW = 576
  integer, parameter :: nGC_MU = 577
  integer, parameter :: nGC_MT = 578
  integer, parameter :: nGC_5171 = 579
  integer, parameter :: nGC_5079 = 580
  integer, parameter :: nGC_7580 = 581
  integer, parameter :: nGC_5172 = 582
  integer, parameter :: nGC_5175 = 583
  integer, parameter :: nGC_5174 = 584
  integer, parameter :: nGC_5177 = 585
  integer, parameter :: nGC_7585 = 586
  integer, parameter :: nGC_5070 = 587
  integer, parameter :: nGC_5178 = 588
  integer, parameter :: nGC_7588 = 589
  integer, parameter :: nGC_5073 = 590
  integer, parameter :: nGC_5074 = 591
  integer, parameter :: nGC_124 = 592
  integer, parameter :: nGC_5076 = 593
  integer, parameter :: nGC_145 = 594
  integer, parameter :: nGC_8665 = 595
  integer, parameter :: nGC_10393 = 596
  integer, parameter :: nGC_4833 = 597
  integer, parameter :: nGC_14580 = 598
  integer, parameter :: nGC_7734 = 599
  integer, parameter :: nGC_773 = 600
  integer, parameter :: nGC_7782 = 601
  integer, parameter :: nGC_7783 = 602
  integer, parameter :: nGC_121 = 603
  integer, parameter :: nGC_5317 = 604
  integer, parameter :: nGC_1273 = 605
  integer, parameter :: nGC_9235 = 606
  integer, parameter :: nGC_5318 = 607
  integer, parameter :: nGC_7821 = 608
  integer, parameter :: nGC_10601 = 609
  integer, parameter :: nGC_10602 = 610
  integer, parameter :: nGC_5316 = 611
  integer, parameter :: nGC_4996 = 612
  integer, parameter :: nGC_321 = 613
  integer, parameter :: nGC_114 = 614
  integer, parameter :: nGC_5431 = 615
  integer, parameter :: nGC_7584 = 616
  integer, parameter :: nGC_10311 = 617
  integer, parameter :: nGC_4930 = 618
  integer, parameter :: nGC_4889 = 619
  integer, parameter :: nGC_5107 = 620
  integer, parameter :: nGC_5290 = 621
  integer, parameter :: nGC_112 = 622
  integer, parameter :: nGC_5311 = 623
  integer, parameter :: nGC_MTA = 624
  integer, parameter :: nGC_10313 = 625
  integer, parameter :: nGC_4875 = 626
  integer, parameter :: nGC_7735 = 627
  integer, parameter :: nGC_7707 = 628
  integer, parameter :: nGC_7737 = 629
  integer, parameter :: nGC_7736 = 630
  integer, parameter :: nGC_5291 = 631
  integer, parameter :: nGC_5422 = 632
  integer, parameter :: nGC_8113 = 633
  integer, parameter :: nGC_4899 = 634
  integer, parameter :: nGC_5383 = 635
  integer, parameter :: nGC_8127 = 636
  integer, parameter :: nGC_32 = 637
  integer, parameter :: nGC_5386 = 638
  integer, parameter :: nGC_5387 = 639
  integer, parameter :: nGC_5310 = 640
  integer, parameter :: nGC_5385 = 641
  integer, parameter :: nGC_4891 = 642
  integer, parameter :: nGC_5146 = 643
  integer, parameter :: nGC_8129 = 644
  integer, parameter :: nGC_9432 = 645
  integer, parameter :: nGC_88 = 646
  integer, parameter :: nGC_10986 = 647
  integer, parameter :: nGC_8632 = 648
  integer, parameter :: nGC_10983 = 649
  integer, parameter :: nGC_80 = 650
  integer, parameter :: nGC_81 = 651
  integer, parameter :: nGC_8516 = 652
  integer, parameter :: nGC_8042 = 653
  integer, parameter :: nGC_435 = 654
  integer, parameter :: nGC_5283 = 655
  integer, parameter :: nGC_8041 = 656
  integer, parameter :: nGC_5180 = 657
  integer, parameter :: nGC_5082 = 658
  integer, parameter :: nGC_5313 = 659
  integer, parameter :: nGC_5185 = 660
  integer, parameter :: nGC_5186 = 661
  integer, parameter :: nGC_5147 = 662
  integer, parameter :: nGC_5188 = 663
  integer, parameter :: nGC_8598 = 664
  integer, parameter :: nGC_5189 = 665
  integer, parameter :: nGC_146 = 666
  integer, parameter :: nGC_8599 = 667
  integer, parameter :: nGC_66 = 668
  integer, parameter :: nGC_67 = 669
  integer, parameter :: nGC_64 = 670
  integer, parameter :: nGC_5293 = 671
  integer, parameter :: nGC_62 = 672
  integer, parameter :: nGC_63 = 673
  integer, parameter :: nGC_60 = 674
  integer, parameter :: nGC_4851 = 675
  integer, parameter :: nGC_4862 = 676
  integer, parameter :: nGC_14582 = 677
  integer, parameter :: nGC_68 = 678
  integer, parameter :: nGC_4965 = 679
  integer, parameter :: nGC_4967 = 680
  integer, parameter :: nGC_4961 = 681
  integer, parameter :: nGC_4853 = 682
  integer, parameter :: nGC_4963 = 683
  integer, parameter :: nGC_4847 = 684
  integer, parameter :: nGC_4814 = 685
  integer, parameter :: nGC_5150 = 686
  integer, parameter :: nGC_4968 = 687
  integer, parameter :: nGC_9238 = 688
  integer, parameter :: nGC_7604 = 689
  integer, parameter :: nGC_5427 = 690
  integer, parameter :: nGC_4808 = 691
  integer, parameter :: nGC_4995 = 692
  integer, parameter :: nGC_4806 = 693
  integer, parameter :: nGC_4807 = 694
  integer, parameter :: nGC_115 = 695
  integer, parameter :: nGC_5062 = 696
  integer, parameter :: nGC_113 = 697
  integer, parameter :: nGC_9680 = 698
  integer, parameter :: nGC_111 = 699
  integer, parameter :: nGC_110 = 700
  integer, parameter :: nGC_5043 = 701
  integer, parameter :: nGC_8240 = 702
  integer, parameter :: nGC_5042 = 703
  integer, parameter :: nGC_5013 = 704
  integer, parameter :: nGC_7543 = 705
  integer, parameter :: nGC_7540 = 706
  integer, parameter :: nGC_8223 = 707
  integer, parameter :: nGC_8224 = 708
  integer, parameter :: nGC_5441 = 709
  integer, parameter :: nGC_5447 = 710
  integer, parameter :: nGC_7904 = 711
  integer, parameter :: nGC_7869 = 712
  integer, parameter :: nGC_7901 = 713
  integer, parameter :: nGC_7909 = 714
  integer, parameter :: nGC_5001 = 715
  integer, parameter :: nGC_5000 = 716
  integer, parameter :: nGC_5003 = 717
  integer, parameter :: nGC_5002 = 718
  integer, parameter :: nGC_5005 = 719
  integer, parameter :: nGC_5004 = 720
  integer, parameter :: nGC_5007 = 721
  integer, parameter :: nGC_5009 = 722
  integer, parameter :: nGC_5008 = 723
  integer, parameter :: nGC_8255 = 724
  integer, parameter :: nGC_5166 = 725
  integer, parameter :: nGC_389 = 726
  integer, parameter :: nGC_5346 = 727
  integer, parameter :: nGC_5228 = 728
  integer, parameter :: nGC_5340 = 729
  integer, parameter :: nGC_5225 = 730
  integer, parameter :: nGC_8148 = 731
  integer, parameter :: nGC_8008 = 732
  integer, parameter :: nGC_8053 = 733
  integer, parameter :: nGC_8820 = 734
  integer, parameter :: nGC_277 = 735
  integer, parameter :: nGC_8110 = 736
  integer, parameter :: nGC_4842 = 737
  integer, parameter :: nGC_7886 = 738
  integer, parameter :: nGC_4840 = 739
  integer, parameter :: nGC_4841 = 740
  integer, parameter :: nGC_4846 = 741
  integer, parameter :: nGC_4844 = 742
  integer, parameter :: nGC_4845 = 743
  integer, parameter :: nGC_4975 = 744
  integer, parameter :: nGC_4849 = 745
  integer, parameter :: nGC_5331 = 746
  integer, parameter :: nGC_10312 = 747
  integer, parameter :: nGC_9005 = 748
  integer, parameter :: nGC_10310 = 749
  integer, parameter :: nGC_8073 = 750
  integer, parameter :: nGC_8176 = 751
  integer, parameter :: nGC_8177 = 752
  integer, parameter :: nGC_9076 = 753
  integer, parameter :: nGC_8175 = 754
  integer, parameter :: nGC_8173 = 755
  integer, parameter :: nGC_9297 = 756
  integer, parameter :: nGC_5406 = 757
  integer, parameter :: nGC_5400 = 758
  integer, parameter :: nGC_5403 = 759
  integer, parameter :: nGC_5409 = 760
  integer, parameter :: nGC_4837 = 761
  integer, parameter :: nGC_4836 = 762
  integer, parameter :: nGC_4835 = 763
  integer, parameter :: nGC_4834 = 764
  integer, parameter :: nGC_4832 = 765
  integer, parameter :: nGC_4938 = 766
  integer, parameter :: nGC_4939 = 767
  integer, parameter :: nGC_4936 = 768
  integer, parameter :: nGC_4937 = 769
  integer, parameter :: nGC_4934 = 770
  integer, parameter :: nGC_4935 = 771
  integer, parameter :: nGC_4932 = 772
  integer, parameter :: nGC_4933 = 773
  integer, parameter :: nGC_4838 = 774
  integer, parameter :: nGC_7947 = 775
  integer, parameter :: nGC_5045 = 776
  integer, parameter :: nGC_5047 = 777
  integer, parameter :: nGC_5041 = 778
  integer, parameter :: nGC_5040 = 779
  integer, parameter :: nGC_8215 = 780
  integer, parameter :: nGC_9859 = 781
  integer, parameter :: nGC_8355 = 782
  integer, parameter :: nGC_5168 = 783
  integer, parameter :: nGC_5169 = 784
  integer, parameter :: nGC_7577 = 785
  integer, parameter :: nGC_5162 = 786
  integer, parameter :: nGC_5163 = 787
  integer, parameter :: nGC_8922 = 788
  integer, parameter :: nGC_7835 = 789
  integer, parameter :: nGC_7831 = 790
  integer, parameter :: nGC_7838 = 791
  integer, parameter :: nGC_5308 = 792
  integer, parameter :: nGC_5302 = 793
  integer, parameter :: nGC_5300 = 794
  integer, parameter :: nGC_5306 = 795
  integer, parameter :: nGC_7932 = 796
  integer, parameter :: nGC_7880 = 797
  integer, parameter :: nGC_2841 = 798
  integer, parameter :: nGC_11068 = 799
  integer, parameter :: nGC_11065 = 800
  integer, parameter :: nGC_337 = 801
  integer, parameter :: nGC_4886 = 802
  integer, parameter :: nGC_7688 = 803
  integer, parameter :: nGC_5274 = 804
  integer, parameter :: nGC_4885 = 805
  integer, parameter :: nGC_4882 = 806
  integer, parameter :: nGC_4893 = 807
  integer, parameter :: nGC_5270 = 808
  integer, parameter :: nGC_9220 = 809
  integer, parameter :: nGC_589 = 810
  integer, parameter :: nGC_5379 = 811
  integer, parameter :: nGC_5376 = 812
  integer, parameter :: nGC_5373 = 813
  integer, parameter :: nGC_5370 = 814
  integer, parameter :: nGC_609 = 815
  integer, parameter :: nGC_4972 = 816
  integer, parameter :: nGC_4970 = 817
  integer, parameter :: nGC_7753 = 818
  integer, parameter :: nGC_4977 = 819
  integer, parameter :: nGC_7750 = 820
  integer, parameter :: nGC_7616 = 821
  integer, parameter :: nGC_4979 = 822
  integer, parameter :: nGC_7613 = 823
  integer, parameter :: nGC_7610 = 824
  integer, parameter :: nGC_7611 = 825
  integer, parameter :: nGC_8147 = 826
  integer, parameter :: nGC_8146 = 827
  integer, parameter :: nGC_5288 = 828
  integer, parameter :: nGC_4872 = 829
  integer, parameter :: nGC_4871 = 830
  integer, parameter :: nGC_5286 = 831
  integer, parameter :: nGC_8149 = 832
  integer, parameter :: nGC_4874 = 833
  integer, parameter :: nGC_5089 = 834
  integer, parameter :: nGC_4950 = 835
  integer, parameter :: nGC_5120 = 836
  integer, parameter :: nGC_5126 = 837
  integer, parameter :: nGC_7535 = 838
  integer, parameter :: nGC_5081 = 839
  integer, parameter :: nGC_5085 = 840
  integer, parameter :: nGC_5087 = 841
  integer, parameter :: nGC_4989 = 842
  integer, parameter :: nGC_5006 = 843
  integer, parameter :: nGC_4906 = 844
  integer, parameter :: nGC_10084 = 845
  integer, parameter :: nGC_767 = 846
  integer, parameter :: nGC_4903 = 847
  integer, parameter :: nGC_10083 = 848
  integer, parameter :: nGC_4985 = 849
  integer, parameter :: nGC_4909 = 850
  integer, parameter :: nGC_4908 = 851
  integer, parameter :: nGC_4984 = 852
  integer, parameter :: nGC_7977 = 853
  integer, parameter :: nGC_7978 = 854
  integer, parameter :: nGC_7875 = 855
  integer, parameter :: nGC_4981 = 856
  integer, parameter :: nGC_8369 = 857
  integer, parameter :: nGC_8368 = 858
  integer, parameter :: nGC_5157 = 859
  integer, parameter :: nGC_5156 = 860
  integer, parameter :: nGC_5154 = 861
  integer, parameter :: nGC_5152 = 862
  integer, parameter :: nGC_5018 = 863
  integer, parameter :: nGC_5019 = 864
  integer, parameter :: nGC_5016 = 865
  integer, parameter :: nGC_5017 = 866
  integer, parameter :: nGC_5014 = 867
  integer, parameter :: nGC_5015 = 868
  integer, parameter :: nGC_5012 = 869
  integer, parameter :: nGC_8659 = 870
  integer, parameter :: nGC_5010 = 871
  integer, parameter :: nGC_5011 = 872
  integer, parameter :: nGC_9245 = 873
  integer, parameter :: nGC_5238 = 874
  integer, parameter :: nGC_5337 = 875
  integer, parameter :: nGC_7809 = 876
  integer, parameter :: nGC_7802 = 877
  integer, parameter :: nGC_7801 = 878
  integer, parameter :: nGC_5276 = 879
  integer, parameter :: nGC_8569 = 880
  integer, parameter :: nGC_8664 = 881
  integer, parameter :: nGC_7723 = 882
  integer, parameter :: nGC_7720 = 883
  integer, parameter :: nGC_8563 = 884
  integer, parameter :: nGC_8562 = 885
  integer, parameter :: nGC_269 = 886
  integer, parameter :: nGC_7768 = 887
  integer, parameter :: nGC_5272 = 888
  integer, parameter :: nGC_8763 = 889
  integer, parameter :: nGC_8762 = 890
  integer, parameter :: nGC_8582 = 891
  integer, parameter :: nGC_8588 = 892
  integer, parameter :: nGC_7652 = 893
  integer, parameter :: nGC_7653 = 894
  integer, parameter :: nGC_7658 = 895
  integer, parameter :: nGC_4964 = 896
  integer, parameter :: nGC_8660 = 897
  integer, parameter :: nGC_7718 = 898
  integer, parameter :: nGC_8666 = 899
  integer, parameter :: nGC_8667 = 900
  integer, parameter :: nGC_5248 = 901
  integer, parameter :: nGC_5246 = 902
  integer, parameter :: nGC_7715 = 903
  integer, parameter :: nGC_7714 = 904
  integer, parameter :: nGC_4905 = 905
  integer, parameter :: nGC_8063 = 906
  integer, parameter :: nGC_9591 = 907
  integer, parameter :: nGC_9590 = 908
  integer, parameter :: nGC_8105 = 909
  integer, parameter :: nGC_4821 = 910
  integer, parameter :: nGC_7774 = 911
  integer, parameter :: nGC_4904 = 912
  integer, parameter :: nGC_5412 = 913
  integer, parameter :: nGC_7623 = 914
  integer, parameter :: nGC_7622 = 915
  integer, parameter :: nGC_5418 = 916
  integer, parameter :: nGC_4824 = 917
  integer, parameter :: nGC_4825 = 918
  integer, parameter :: nGC_4949 = 919
  integer, parameter :: nGC_4827 = 920
  integer, parameter :: nGC_9218 = 921
  integer, parameter :: nGC_9219 = 922
  integer, parameter :: nGC_4822 = 923
  integer, parameter :: nGC_4823 = 924
  integer, parameter :: nGC_4943 = 925
  integer, parameter :: nGC_4942 = 926
  integer, parameter :: nGC_4941 = 927
  integer, parameter :: nGC_4947 = 928
  integer, parameter :: nGC_4946 = 929
  integer, parameter :: nGC_5343 = 930
  integer, parameter :: nGC_7709 = 931
  integer, parameter :: nGC_10592 = 932
  integer, parameter :: nGC_10595 = 933
  integer, parameter :: nGC_10596 = 934
  integer, parameter :: nGC_5119 = 935
  integer, parameter :: nGC_7569 = 936
  integer, parameter :: nGC_5112 = 937
  integer, parameter :: nGC_5111 = 938
  integer, parameter :: nGC_5117 = 939
  integer, parameter :: nGC_5116 = 940
  integer, parameter :: nGC_7563 = 941
  integer, parameter :: nGC_5466 = 942
  integer, parameter :: nGC_5465 = 943
  integer, parameter :: nGC_5464 = 944
  integer, parameter :: nGC_7841 = 945
  integer, parameter :: nGC_7840 = 946
  integer, parameter :: nGC_1351 = 947
  integer, parameter :: nGC_10628 = 948
  integer, parameter :: nGC_9520 = 949
  integer, parameter :: nGC_9521 = 950
  integer, parameter :: nGC_7922 = 951
  integer, parameter :: nGC_7923 = 952
  integer, parameter :: nGC_5027 = 953
  integer, parameter :: nGC_5026 = 954
  integer, parameter :: nGC_5025 = 955
  integer, parameter :: nGC_5024 = 956
  integer, parameter :: nGC_5023 = 957
  integer, parameter :: nGC_5022 = 958
  integer, parameter :: nGC_5021 = 959
  integer, parameter :: nGC_5020 = 960
  integer, parameter :: nGC_5029 = 961
  integer, parameter :: nGC_5028 = 962
  integer, parameter :: nGC_7690 = 963
  integer, parameter :: nGC_7691 = 964
  integer, parameter :: nGC_5201 = 965
  integer, parameter :: nGC_13228 = 966
  integer, parameter :: nGC_5207 = 967
  integer, parameter :: nGC_8537 = 968
  integer, parameter :: nGC_8534 = 969
  integer, parameter :: nGC_5364 = 970
  integer, parameter :: nGC_5361 = 971
  integer, parameter :: nGC_9003 = 972
  integer, parameter :: nGC_9002 = 973
  integer, parameter :: nGC_8925 = 974
  integer, parameter :: nGC_8021 = 975
  integer, parameter :: nGC_8022 = 976
  integer, parameter :: nGC_8027 = 977
  integer, parameter :: nGC_7669 = 978
  integer, parameter :: nGC_4987 = 979
  integer, parameter :: nGC_4986 = 980
  integer, parameter :: nGC_7661 = 981
  integer, parameter :: nGC_7660 = 982
  integer, parameter :: nGC_4983 = 983
  integer, parameter :: nGC_4982 = 984
  integer, parameter :: nGC_4980 = 985
  integer, parameter :: nGC_8157 = 986
  integer, parameter :: nGC_8151 = 987
  integer, parameter :: nGC_4860 = 988
  integer, parameter :: nGC_4861 = 989
  integer, parameter :: nGC_5292 = 990
  integer, parameter :: nGC_5294 = 991
  integer, parameter :: nGC_4865 = 992
  integer, parameter :: nGC_4866 = 993
  integer, parameter :: nGC_5096 = 994
  integer, parameter :: nGC_5097 = 995
  integer, parameter :: nGC_5094 = 996
  integer, parameter :: nGC_7520 = 997
  integer, parameter :: nGC_7523 = 998
  integer, parameter :: nGC_5429 = 999
  integer, parameter :: nGC_4948 = 1000
  integer, parameter :: nGC_4910 = 1001
  integer, parameter :: nGC_4911 = 1002
  integer, parameter :: nGC_4912 = 1003
  integer, parameter :: nGC_5423 = 1004
  integer, parameter :: nGC_9677 = 1005
  integer, parameter :: nGC_5421 = 1006
  integer, parameter :: nGC_9672 = 1007
  integer, parameter :: nGC_9671 = 1008
  integer, parameter :: nGC_7960 = 1009
  integer, parameter :: nGC_7961 = 1010
  integer, parameter :: nGC_7967 = 1011
  integer, parameter :: nGC_7968 = 1012
  integer, parameter :: nGC_7969 = 1013
  integer, parameter :: nGC_4971 = 1014
  integer, parameter :: nGC_8376 = 1015
  integer, parameter :: nGC_8377 = 1016
  integer, parameter :: nGC_4976 = 1017
  integer, parameter :: nGC_9246 = 1018
  integer, parameter :: nGC_7595 = 1019
  integer, parameter :: nGC_7594 = 1020
  integer, parameter :: nGC_7591 = 1021
  integer, parameter :: nGC_4974 = 1022
  integer, parameter :: nGC_5142 = 1023
  integer, parameter :: nGC_4828 = 1024
  integer, parameter :: nGC_7619 = 1025
  integer, parameter :: nGC_7599 = 1026
  integer, parameter :: nGC_7647 = 1027
  integer, parameter :: nGC_5065 = 1028
  integer, parameter :: nGC_4829 = 1029
  integer, parameter :: nGC_4944 = 1030
  integer, parameter :: nGC_4830 = 1031
  integer, parameter :: nGC_5038 = 1032
  integer, parameter :: nGC_9458 = 1033
  integer, parameter :: nGC_7819 = 1034
  integer, parameter :: nGC_8185 = 1035
  integer, parameter :: nGC_7810 = 1036
  integer, parameter :: nGC_7726 = 1037
  integer, parameter :: nGC_8574 = 1038
  integer, parameter :: nGC_253 = 1039
  integer, parameter :: nGC_5144 = 1040
  integer, parameter :: nGC_4843 = 1041
  integer, parameter :: nGC_4818 = 1042
  integer, parameter :: nGC_12637 = 1043
  integer, parameter :: nGC_12636 = 1044
  integer, parameter :: nGC_12634 = 1045
  integer, parameter :: nGC_5068 = 1046
  integer, parameter :: nGC_7883 = 1047
  integer, parameter :: nGC_8987 = 1048
  integer, parameter :: nGC_8984 = 1049
  integer, parameter :: nGC_5394 = 1050
  integer, parameter :: nGC_5397 = 1051
  integer, parameter :: nGC_5258 = 1052
  integer, parameter :: nGC_7881 = 1053
  integer, parameter :: nGC_9374 = 1054
  integer, parameter :: nGC_9423 = 1055
  integer, parameter :: nGC_9422 = 1056
  integer, parameter :: nGC_9421 = 1057
  integer, parameter :: nGC_8050 = 1058
  integer, parameter :: nGC_8974 = 1059
  integer, parameter :: nGC_8975 = 1060
  integer, parameter :: nGC_8055 = 1061
  integer, parameter :: nGC_8056 = 1062
  integer, parameter :: nGC_8507 = 1063
  integer, parameter :: nGC_8506 = 1064
  integer, parameter :: nGC_5284 = 1065
  integer, parameter :: nGC_5193 = 1066
  integer, parameter :: nGC_5195 = 1067
  integer, parameter :: nGC_7889 = 1068
  integer, parameter :: nGC_7888 = 1069
  integer, parameter :: nGC_7685 = 1070
  integer, parameter :: nGC_8403 = 1071
  integer, parameter :: nGC_4811 = 1072
  integer, parameter :: nGC_4959 = 1073
  integer, parameter :: nGC_4813 = 1074
  integer, parameter :: nGC_8607 = 1075
  integer, parameter :: nGC_4815 = 1076
  integer, parameter :: nGC_4817 = 1077
  integer, parameter :: nGC_4816 = 1078
  integer, parameter :: nGC_4819 = 1079
  integer, parameter :: nGC_9078 = 1080
  integer, parameter :: nGC_4952 = 1081
  integer, parameter :: nGC_4953 = 1082
  integer, parameter :: nGC_4954 = 1083
  integer, parameter :: nGC_4955 = 1084
  integer, parameter :: nGC_4956 = 1085
  integer, parameter :: nGC_4957 = 1086
  integer, parameter :: nGC_4898 = 1087
  integer, parameter :: nGC_4887 = 1088
  integer, parameter :: nGC_9075 = 1089
  integer, parameter :: nGC_9833 = 1090
  integer, parameter :: nGC_9835 = 1091
  integer, parameter :: nGC_9836 = 1092
  integer, parameter :: nGC_5108 = 1093
  integer, parameter :: nGC_5109 = 1094
  integer, parameter :: nGC_5102 = 1095
  integer, parameter :: nGC_5103 = 1096
  integer, parameter :: nGC_7555 = 1097
  integer, parameter :: nGC_7566 = 1098
  integer, parameter :: nGC_7851 = 1099
  integer, parameter :: nGC_7854 = 1100
  integer, parameter :: nGC_7857 = 1101
  integer, parameter :: nGC_7858 = 1102
  integer, parameter :: nGC_4894 = 1103
  integer, parameter :: nGC_4896 = 1104
  integer, parameter :: nGC_7915 = 1105
  integer, parameter :: nGC_7914 = 1106
  integer, parameter :: nGC_5034 = 1107
  integer, parameter :: nGC_8308 = 1108
  integer, parameter :: nGC_5036 = 1109
  integer, parameter :: nGC_5037 = 1110
  integer, parameter :: nGC_5030 = 1111
  integer, parameter :: nGC_5031 = 1112
  integer, parameter :: nGC_5032 = 1113
  integer, parameter :: nGC_5033 = 1114
  integer, parameter :: nGC_8305 = 1115
  integer, parameter :: nGC_5039 = 1116
  integer, parameter :: nGC_8307 = 1117
  integer, parameter :: nGC_5035 = 1118
  integer, parameter :: nGC_5358 = 1119
  integer, parameter :: nGC_8540 = 1120
  integer, parameter :: nGC_7988 = 1121
  integer, parameter :: nGC_881 = 1122
  integer, parameter :: nGC_7664 = 1123
  integer, parameter :: nGC_5355 = 1124
  integer, parameter :: nGC_8783 = 1125
  integer, parameter :: nGC_8394 = 1126
  integer, parameter :: nGC_4988 = 1127
  integer, parameter :: nGC_8186 = 1128
  integer, parameter :: nGC_7985 = 1129
  integer, parameter :: nGC_10390 = 1130
  integer, parameter :: nGC_10394 = 1131
  integer, parameter :: nGC_7771 = 1132
  integer, parameter :: nGC_7775 = 1133
  integer, parameter :: nGC_4999 = 1134
  integer, parameter :: nGC_4994 = 1135
  integer, parameter :: nGC_7672 = 1136
  integer, parameter :: nGC_4858 = 1137
  integer, parameter :: nGC_8649 = 1138
  integer, parameter :: nGC_10085 = 1139
  integer, parameter :: nGC_2637 = 1140
  integer, parameter :: nGC_5438 = 1141
  integer, parameter :: nGC_4923 = 1142
  integer, parameter :: nGC_9760 = 1143
  integer, parameter :: nGC_9761 = 1144
  integer, parameter :: nGC_9762 = 1145
  integer, parameter :: nGC_4926 = 1146
  integer, parameter :: nGC_4929 = 1147
  integer, parameter :: nGC_5432 = 1148
  integer, parameter :: nGC_7952 = 1149
  integer, parameter :: nGC_5078 = 1150
  integer, parameter :: nGC_7581 = 1151
  integer, parameter :: nGC_5072 = 1152
  integer, parameter :: nGC_5075 = 1153
  integer, parameter :: nGC_9112 = 1154
  integer, parameter :: nGC_4831 = 1155
  integer, parameter :: nGC_8864 = 1156
  integer, parameter :: nGC_8867 = 1157
  integer, parameter :: nGC_8721 = 1158
  integer, parameter :: nGC_8862 = 1159
  integer, parameter :: nGC_8863 = 1160
  integer, parameter :: nGC_5319 = 1161
  integer, parameter :: nGC_8196 = 1162
  integer, parameter :: nGC_11291 = 1163
  integer, parameter :: nGC_4962 = 1164
  integer, parameter :: nGC_4810 = 1165
  integer, parameter :: nGC_8291 = 1166
  integer, parameter :: nGC_8290 = 1167
  integer, parameter :: nGC_8745 = 1168
  integer, parameter :: nGC_9862 = 1169
  integer, parameter :: nGC_7730 = 1170
  integer, parameter :: nGC_5382 = 1171
  integer, parameter :: nGC_5268 = 1172
  integer, parameter :: nGC_5260 = 1173
  integer, parameter :: nGC_5388 = 1174
  integer, parameter :: nGC_4892 = 1175
  integer, parameter :: nGC_4895 = 1176
  integer, parameter :: nGC_4812 = 1177
  integer, parameter :: nGC_4897 = 1178
  integer, parameter :: nGC_5266 = 1179
  integer, parameter :: nGC_8048 = 1180
  integer, parameter :: nGC_8045 = 1181
  integer, parameter :: nGC_5187 = 1182
  integer, parameter :: nGC_9302 = 1183
  integer, parameter :: nGC_9303 = 1184
  integer, parameter :: nGC_7601 = 1185
  integer, parameter :: nGC_4951 = 1186
  integer, parameter :: nGC_7603 = 1187
  integer, parameter :: nGC_4966 = 1188
  integer, parameter :: nGC_9232 = 1189
  integer, parameter :: nGC_4960 = 1190
  integer, parameter :: nGC_9231 = 1191
  integer, parameter :: nGC_4969 = 1192
  integer, parameter :: nGC_8358 = 1193
  integer, parameter :: nGC_7670 = 1194
  integer, parameter :: nGC_4809 = 1195
  integer, parameter :: nGC_4805 = 1196
  integer, parameter :: nGC_8587 = 1197
  integer, parameter :: nGC_9295 = 1198
  integer, parameter :: nGC_7538 = 1199
  integer, parameter :: nGC_9398 = 1200
  integer, parameter :: nGC_7534 = 1201
  integer, parameter :: nGC_8950 = 1202
  integer, parameter :: nGC_7776 = 1203
  integer, parameter :: nGC_7874 = 1204
  integer, parameter :: nGC_7546 = 1205
  integer, parameter :: nGC_7545 = 1206
  integer, parameter :: nGC_8187 = 1207
  integer, parameter :: nGC_7571 = 1208
  integer, parameter :: nGC_7742 = 1209
  integer, parameter :: nGC_7570 = 1210
  integer, parameter :: nGC_8227 = 1211
  integer, parameter :: nGC_7549 = 1212
  integer, parameter :: nGC_8028 = 1213
  integer, parameter :: nGC_4998 = 1214
  integer, parameter :: nGC_11069 = 1215
  integer, parameter :: nGC_9635 = 1216
  integer, parameter :: nGC_7564 = 1217
  integer, parameter :: nGC_4978 = 1218
  integer, parameter :: nGC_9006 = 1219
  integer, parameter :: nGC_9431 = 1220
  integer, parameter :: nGC_8539 = 1221
  integer, parameter :: nGC_4958 = 1222
  integer, parameter :: nGC_7955 = 1223
  integer, parameter :: nGC_8822 = 1224
  integer, parameter :: nGC_8823 = 1225
  integer, parameter :: nGC_7954 = 1226
  integer, parameter :: nGC_4870 = 1227
  integer, parameter :: nGC_8107 = 1228
  integer, parameter :: nGC_8106 = 1229
  integer, parameter :: nGC_7673 = 1230
  integer, parameter :: nGC_7903 = 1231
  integer, parameter :: nGC_7861 = 1232
  integer, parameter :: nGC_7665 = 1233
  integer, parameter :: nGC_9681 = 1234
  integer, parameter :: nGC_7596 = 1235
  integer, parameter :: nGC_7641 = 1236
  integer, parameter :: nGC_7640 = 1237
  integer, parameter :: nGC_7725 = 1238
  integer, parameter :: nGC_7682 = 1239
  integer, parameter :: nGC_13234 = 1240
  integer, parameter :: nGC_7824 = 1241
  integer, parameter :: nGC_9600 = 1242
  integer, parameter :: nGC_8406 = 1243
  integer, parameter :: nGC_8722 = 1244
  integer, parameter :: nGC_8404 = 1245
  integer, parameter :: nGC_8405 = 1246
  integer, parameter :: nGC_7892 = 1247
  integer, parameter :: nGC_7618 = 1248
  integer, parameter :: nGC_7696 = 1249
  integer, parameter :: nGC_8258 = 1250
  integer, parameter :: nGC_9184 = 1251
  integer, parameter :: nGC_7550 = 1252
  integer, parameter :: nGC_7764 = 1253
  integer, parameter :: nGC_9424 = 1254
  integer, parameter :: nGC_7760 = 1255
  integer, parameter :: nGC_7761 = 1256
  integer, parameter :: nGC_10086 = 1257
  integer, parameter :: nGC_8156 = 1258
  integer, parameter :: nGC_9079 = 1259
  integer, parameter :: nGC_8178 = 1260
  integer, parameter :: nGC_9763 = 1261
  integer, parameter :: nGC_8839 = 1262
  integer, parameter :: nGC_7743 = 1263
  integer, parameter :: nGC_4864 = 1264
  integer, parameter :: nGC_8336 = 1265
  integer, parameter :: nGC_8079 = 1266
  integer, parameter :: nGC_8078 = 1267
  integer, parameter :: nGC_7697 = 1268
  integer, parameter :: nGC_7765 = 1269
  integer, parameter :: nGC_10605 = 1270
  integer, parameter :: nGC_8337 = 1271
  integer, parameter :: nGC_7698 = 1272
  integer, parameter :: nGC_9239 = 1273
  integer, parameter :: nGC_9240 = 1274
  integer, parameter :: nGC_10606 = 1275
  integer, parameter :: nGC_9465 = 1276
  integer, parameter :: nGC_7683 = 1277
  integer, parameter :: nGC_8838 = 1278
  integer, parameter :: nGC_7825 = 1279
  integer, parameter :: nGC_8115 = 1280
  integer, parameter :: nGC_8116 = 1281
  contains
  function get_coupling_value_mdl(c_id) result(ret_c)
    integer, intent(in) :: c_id
    complex(dp) :: ret_c
    if (c_id .eq. 0) then
      ret_c = cnul
    else
      ret_c = coupl(c_id)
    end if
  end function get_coupling_value_mdl
end module class_couplings
