!******************************************************************************!
!                                                                              !
!    fill_couplings1.f90                                                       !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   fill_couplings1.f90                            |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 11/2018                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2020-07-30 18:24             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module fill_couplings1
  use constants_mdl
  use class_couplings
  use class_ctparameters
  implicit none
  contains
  subroutine fill_couplings_mdl1()
    coupl(nGC_89) = sqrt(2d0)*CZlL1x1*cima*ee*kZL/(cw*sw)
    coupl(nGC_5134) = -sqrt(2d0)/2d0
    coupl(nGC_5137) = -sqrt(2d0)*cima/2d0
    coupl(nGC_5158) = sqrt(2d0)/2d0
    coupl(nGC_5440) = cima*ee*(3d0*cw**2d0 - sw**2d0)/(6d0*cw*sw**2d0)
    coupl(nGC_5443) = -cima*ee*(cw - sw)*(cw + sw)/(2d0*cw*sw**2d0)
    coupl(nGC_5442) = cima*ee*(cw - sw)*(cw + sw)/(2d0*cw**2d0*sw)
    coupl(nGC_5445) = -cima*ee*sw/cw**2d0
    coupl(nGC_5446) = cima*ee/cw
    coupl(nGC_5395) = -sqrt(2d0)*cima*ee*kZR*(CZuR1x3 + CZuR3x1)/(2d0*cw**2d0* &
                      sw)
    coupl(nGC_I) = cima
    coupl(nGC_5424) = -sqrt(2d0)*cima*ee*sb/(2d0*sw**2d0)
    coupl(nGC_5148) = -sqrt(2d0)*cima/2d0
    coupl(nGC_5390) = -sqrt(2d0)*cima*ee*kZL*(CZuL1x2 + CZuL2x1)/(2d0*cw*sw**  &
                      2d0)
    coupl(nGC_83) = sqrt(2d0)*CWqR3x1*cima*ee*kWR/(2d0*sw)
    coupl(nGC_5312) = -sqrt(2d0)*CZdR1x1*cima*ee*kZR/(cw*sw**2d0)
    coupl(nGC_5295) = -sqrt(2d0)*CWlL2x3*cima*ee*kWL/(2d0*sw**2d0)
    coupl(nGC_5347) = -sqrt(2d0)*CZlR1x1*cima*ee*kZR/(cw**2d0*sw)
    coupl(nGC_5344) = -sqrt(2d0)*CZdR3x3*cima*ee*kZR/(cw**2d0*sw)
    coupl(nGC_5345) = -sqrt(2d0)*CZdR3x3*cima*ee*kZR/(cw*sw**2d0)
    coupl(nGC_5229) = cima*ee**2d0*vev*(cw - sw)*(cw + sw)*(cw**2d0 + sw**2d0  &
                      )/(cw**3d0*sw**2d0)
    coupl(nGC_5341) = -sqrt(2d0)*CZdL3x3*cima*ee*kZL/(cw**2d0*sw)
    coupl(nGC_5224) = -cima*ee**2d0*(cw - sw)*(cw + sw)*(cw**2d0 + sw**2d0)/(cw&
                      **2d0*sw**3d0)
    coupl(nGC_5227) = -cima*ee**2d0*(cw - sw)*(cw + sw)*(cw**2d0 + sw**2d0)/(cw&
                      **2d0*sw**3d0)
    coupl(nGC_5226) = cima*ee**2d0*(cw - sw)*(cw + sw)*(cw**2d0 + sw**2d0)/(cw &
                      **3d0*sw**2d0)
    coupl(nGC_5221) = -2d0*cima*cw*ee**2d0/sw**2d0
    coupl(nGC_5220) = 2d0*cima*ee**2d0/sw
    coupl(nGC_5223) = cima*ee**2d0*(cw - sw)*(cw + sw)*(cw**2d0 + sw**2d0)/(cw &
                      **3d0*sw**2d0)
    coupl(nGC_30) = sqrt(2d0)*CZlR1x3*cima*ee*kZR/(2d0*cw*sw) + sqrt(2d0)*     &
                    CZlR3x1*cima*ee*kZR/(2d0*cw*sw)
    coupl(nGC_101) = sqrt(2d0)*CZuR1x1*cima*ee*kZR/(cw*sw)
    coupl(nGC_MC) = -cMC*cima
    coupl(nGC_MZ_GF) = cMZ
    coupl(nGC_98) = sqrt(2d0)*CZlR1x1*cima*ee*kZR/(cw*sw)
    coupl(nGC_5253) = -sqrt(2d0)*CWqR2x1*cima*ee*kWR/(2d0*sw**2d0)
    coupl(nGC_102) = sqrt(2d0)*CZuR2x2*cima*ee*kZR/(cw*sw)
    coupl(nGC_28) = sqrt(2d0)*CZdR2x3*cima*ee*kZR/(2d0*cw*sw) + sqrt(2d0)*     &
                    CZdR3x2*cima*ee*kZR/(2d0*cw*sw)
    coupl(nGC_29) = sqrt(2d0)*CZlR1x2*cima*ee*kZR/(2d0*cw*sw) + sqrt(2d0)*     &
                    CZlR2x1*cima*ee*kZR/(2d0*cw*sw)
    coupl(nGC_96) = sqrt(2d0)*CZdR2x2*cima*ee*kZR/(cw*sw)
    coupl(nGC_22) = sqrt(2d0)*CZlL2x3*cima*ee*kZL/(2d0*cw*sw) + sqrt(2d0)*     &
                    CZlL3x2*cima*ee*kZL/(2d0*cw*sw)
    coupl(nGC_23) = sqrt(2d0)*CZuL1x2*cima*ee*kZL/(2d0*cw*sw) + sqrt(2d0)*     &
                    CZuL2x1*cima*ee*kZL/(2d0*cw*sw)
    coupl(nGC_20) = sqrt(2d0)*CZlL1x2*cima*ee*kZL/(2d0*cw*sw) + sqrt(2d0)*     &
                    CZlL2x1*cima*ee*kZL/(2d0*cw*sw)
    coupl(nGC_21) = sqrt(2d0)*CZlL1x3*cima*ee*kZL/(2d0*cw*sw) + sqrt(2d0)*     &
                    CZlL3x1*cima*ee*kZL/(2d0*cw*sw)
    coupl(nGC_26) = sqrt(2d0)*CZdR1x2*cima*ee*kZR/(2d0*cw*sw) + sqrt(2d0)*     &
                    CZdR2x1*cima*ee*kZR/(2d0*cw*sw)
    coupl(nGC_27) = sqrt(2d0)*CZdR1x3*cima*ee*kZR/(2d0*cw*sw) + sqrt(2d0)*     &
                    CZdR3x1*cima*ee*kZR/(2d0*cw*sw)
    coupl(nGC_24) = sqrt(2d0)*CZuL1x3*cima*ee*kZL/(2d0*cw*sw) + sqrt(2d0)*     &
                    CZuL3x1*cima*ee*kZL/(2d0*cw*sw)
    coupl(nGC_25) = sqrt(2d0)*CZuL2x3*cima*ee*kZL/(2d0*cw*sw) + sqrt(2d0)*     &
                    CZuL3x2*cima*ee*kZL/(2d0*cw*sw)
    coupl(nGC_153) = sqrt(2d0)*sb*ys/2d0
    coupl(nGC_152) = sqrt(2d0)*cima*sb*ys/2d0
    coupl(nGC_151) = -sqrt(2d0)*sb*ys/2d0
    coupl(nGC_150) = -sqrt(2d0)*cb*cima*ys/2d0
    coupl(nGC_157) = -cima*ytau
    coupl(nGC_156) = sqrt(2d0)*yt/2d0
    coupl(nGC_155) = -sqrt(2d0)*cima*yt/2d0
    coupl(nGC_154) = cima*yt
    coupl(nGC_93) = sqrt(2d0)*CZuL2x2*cima*ee*kZL/(cw*sw)
    coupl(nGC_159) = -sqrt(2d0)*cima*ytau/2d0
    coupl(nGC_158) = -sqrt(2d0)*ytau/2d0
    coupl(nGC_5239) = -sqrt(2d0)*CWqR1x1*cima*ee*kWR/(2d0*sw**2d0)
    coupl(nGC_91) = sqrt(2d0)*CZlL3x3*cima*ee*kZL/(cw*sw)
    coupl(nGC_5335) = -sqrt(2d0)*cima*ee*kZR*(CZdR2x3 + CZdR3x2)/(2d0*cw**2d0* &
                      sw)
    coupl(nGC_5190) = ee**2d0/(2d0*sw**2d0)
    coupl(nGC_5362) = -sqrt(2d0)*cima*ee*kZL*(CZlL1x3 + CZlL3x1)/(2d0*cw**2d0* &
                      sw)
    coupl(nGC_5263) = -sqrt(2d0)*CWqR3x1*cima*ee*kWR/(2d0*sw**2d0)
    coupl(nGC_148) = -cima*ys
    coupl(nGC_MWp) = cMWp**2d0*cima
    coupl(nGC_5230) = -cima*ee**2d0*vev*(cw - sw)*(cw + sw)*(cw**2d0 + sw**2d0 &
                      )/(cw**2d0*sw**3d0)
    coupl(nGC_5405) = -sqrt(2d0)*CZuL2x2*cima*ee*kZL/(cw*sw**2d0)
    coupl(nGC_5404) = -sqrt(2d0)*CZuL2x2*cima*ee*kZL/(cw**2d0*sw)
    coupl(nGC_5407) = -sqrt(2d0)*cima*ee*kZL*(CZuL2x3 + CZuL3x2)/(2d0*cw**2d0* &
                      sw)
    coupl(nGC_5231) = cima*ee**2d0*(cw**2d0 + sw**2d0)**2d0/(2d0*cw**2d0*sw**  &
                      2d0)
    coupl(nGC_5401) = -sqrt(2d0)*CZuR2x2*cima*ee*kZR/(cw**2d0*sw)
    coupl(nGC_5402) = -sqrt(2d0)*CZuR2x2*cima*ee*kZR/(cw*sw**2d0)
    coupl(nGC_5408) = -sqrt(2d0)*cima*ee*kZL*(CZuL2x3 + CZuL3x2)/(2d0*cw*sw**  &
                      2d0)
    coupl(nGC_5237) = -2d0*cima*cw**2d0*ee**2d0/sw**3d0
    coupl(nGC_126) = cima*ee**2d0*vev/(2d0*sw**2d0)
    coupl(nGC_127) = -cima*ee**2d0*vev/(2d0*sw)
    coupl(nGC_125) = -3d0*cima*lam*vev/2d0
    coupl(nGC_122) = cima*cw**2d0*ee**2d0/(2d0*sw**2d0) + cima*ee**2d0 + cima* &
                     ee**2d0*sw**2d0/(2d0*cw**2d0)
    coupl(nGC_123) = -cima*ee**2d0*vev/(2d0*cw)
    coupl(nGC_120) = -cMZ*cima*cw*ee/(2d0*sw) - cMZ*cima*ee*sw/(2d0*cw)
    coupl(nGC_128) = cima*cw**2d0*ee**2d0*vev/(2d0*sw**2d0) + cima*ee**2d0*vev &
                      + cima*ee**2d0*sw**2d0*vev/(2d0*cw**2d0)
    coupl(nGC_129) = -cima*yb
    coupl(nGC_1917) = -coupl(nGC_158)
    coupl(nGC_5281) = -sqrt(2d0)*CWlR1x2*cima*ee*kWR/(2d0*sw**2d0)
    coupl(nGC_100) = sqrt(2d0)*CZlR3x3*cima*ee*kZR/(cw*sw)
    coupl(nGC_5044) = -3d0*cima/2d0
    coupl(nGC_5046) = -cima/2d0
    coupl(nGC_MMW_GF) = -cMW*cima
    coupl(nGC_5049) = -cima*vev/2d0
    coupl(nGC_5167) = sqrt(2d0)/2d0
    coupl(nGC_5164) = -cima*sb
    coupl(nGC_5161) = -sqrt(2d0)*cima/2d0
    coupl(nGC_5261) = -sqrt(2d0)*CWqL2x3*cima*ee*kWL/(2d0*sw**2d0)
    coupl(nGC_70) = sqrt(2d0)*CWlR1x3*cima*ee*kWR/(2d0*sw)
    coupl(nGC_5309) = -sqrt(2d0)*CWlR3x3*cima*ee*kWR/(2d0*sw**2d0)
    coupl(nGC_5303) = -sqrt(2d0)*CWlL3x2*cima*ee*kWL/(2d0*sw**2d0)
    coupl(nGC_5301) = -sqrt(2d0)*CWlL3x1*cima*ee*kWL/(2d0*sw**2d0)
    coupl(nGC_5307) = -sqrt(2d0)*CWlL3x3*cima*ee*kWL/(2d0*sw**2d0)
    coupl(nGC_5305) = -sqrt(2d0)*CWlR3x2*cima*ee*kWR/(2d0*sw**2d0)
    coupl(nGC_69) = sqrt(2d0)*CWlR1x2*cima*ee*kWR/(2d0*sw)
    coupl(nGC_109) = sqrt(2d0)*cima*ee*sb/(2d0*sw)
    coupl(nGC_140) = -sqrt(2d0)*cima*sb*ydo/2d0
    coupl(nGC_65) = sqrt(2d0)*CWqL3x1*cima*ee*kWL/(2d0*sw)
    coupl(nGC_5384) = -sqrt(2d0)*CZuR1x1*cima*ee*kZR/(cw*sw**2d0)
    coupl(nGC_5277) = -sqrt(2d0)*CWlL1x1*cima*ee*kWL/(2d0*sw**2d0)
    coupl(nGC_5275) = -sqrt(2d0)*CWlR1x1*cima*ee*kWR/(2d0*sw**2d0)
    coupl(nGC_5273) = -sqrt(2d0)*CWqR3x3*cima*ee*kWR/(2d0*sw**2d0)
    coupl(nGC_5271) = -sqrt(2d0)*CWqL3x3*cima*ee*kWL/(2d0*sw**2d0)
    coupl(nGC_5279) = -sqrt(2d0)*CWlL1x2*cima*ee*kWL/(2d0*sw**2d0)
    coupl(nGC_3) = -cima*ee
    coupl(nGC_2) = -2d0*cima*ee/3d0
    coupl(nGC_1) = cima*ee/3d0
    coupl(nGC_5433) = 2d0*cima*ee*sw/(3d0*cw**2d0)
    coupl(nGC_7) = -ee**2d0/(2d0*cw)
    coupl(nGC_6) = 2d0*cima*ee**2d0
    coupl(nGC_5) = cima*ee**2d0
    coupl(nGC_4) = cima*ee
    coupl(nGC_5377) = -sqrt(2d0)*CZlL3x3*cima*ee*kZL/(cw**2d0*sw)
    coupl(nGC_9) = ee**2d0/(2d0*cw)
    coupl(nGC_8) = -cima*ee**2d0/(2d0*cw)
    coupl(nGC_5372) = -sqrt(2d0)*cima*ee*kZL*(CZlL2x3 + CZlL3x2)/(2d0*cw*sw**  &
                      2d0)
    coupl(nGC_5371) = -sqrt(2d0)*cima*ee*kZL*(CZlL2x3 + CZlL3x2)/(2d0*cw**2d0* &
                      sw)
    coupl(nGC_15) = -3d0*cima*lam/2d0
    coupl(nGC_53) = sqrt(2d0)*CWlL2x1*cima*ee*kWL/(2d0*sw)
    coupl(nGC_52) = sqrt(2d0)*CWlL1x3*cima*ee*kWL/(2d0*sw)
    coupl(nGC_51) = sqrt(2d0)*CWlL1x2*cima*ee*kWL/(2d0*sw)
    coupl(nGC_50) = sqrt(2d0)*CWlL1x1*cima*ee*kWL/(2d0*sw)
    coupl(nGC_57) = sqrt(2d0)*CWlL3x2*cima*ee*kWL/(2d0*sw)
    coupl(nGC_56) = sqrt(2d0)*CWlL3x1*cima*ee*kWL/(2d0*sw)
    coupl(nGC_55) = sqrt(2d0)*CWlL2x3*cima*ee*kWL/(2d0*sw)
    coupl(nGC_54) = sqrt(2d0)*CWlL2x2*cima*ee*kWL/(2d0*sw)
    coupl(nGC_59) = sqrt(2d0)*CWqL1x1*cima*ee*kWL/(2d0*sw)
    coupl(nGC_58) = sqrt(2d0)*CWlL3x3*cima*ee*kWL/(2d0*sw)
    coupl(nGC_12) = cima*gs**2d0
    coupl(nGC_5289) = -sqrt(2d0)*CWlL2x1*cima*ee*kWL/(2d0*sw**2d0)
    coupl(nGC_517) = -coupl(nGC_4)
    coupl(nGC_MB) = -cMB*cima
    coupl(nGC_162) = cb*cima*yup
    coupl(nGC_163) = cima*sb*yup
    coupl(nGC_160) = -sqrt(2d0)*cima*yup/2d0
    coupl(nGC_161) = sqrt(2d0)*yup/2d0
    coupl(nGC_5287) = -sqrt(2d0)*CWlR2x1*cima*ee*kWR/(2d0*sw**2d0)
    coupl(nGC_5285) = -sqrt(2d0)*CWlR1x3*cima*ee*kWR/(2d0*sw**2d0)
    coupl(nGC_106) = cMW*ee/(2d0*sw)
    coupl(nGC_MZp) = cMZp**2d0*cima
    coupl(nGC_107) = cMZ*cima*ee/(2d0*sw)
    coupl(nGC_5389) = -sqrt(2d0)*cima*ee*kZL*(CZuL1x2 + CZuL2x1)/(2d0*cw**2d0* &
                      sw)
    coupl(nGC_5088) = 2d0*cima*gs**2d0
    coupl(nGC_5121) = sqrt(2d0)*sb/2d0
    coupl(nGC_5127) = -sqrt(2d0)*cb*cima/2d0
    coupl(nGC_5124) = -sqrt(2d0)*cb/2d0
    coupl(nGC_5080) = -cMZ*cima*ee/(2d0*sw**2d0)
    coupl(nGC_5084) = cMZ*cima*ee*(cw - sw)*(cw + sw)/(2d0*cw*sw**2d0)
    coupl(nGC_5086) = -gs
    coupl(nGC_MZ) = cMZ**2d0*cima
    coupl(nGC_78) = sqrt(2d0)*CWqR1x2*cima*ee*kWR/(2d0*sw)
    coupl(nGC_5155) = cima*sb
    coupl(nGC_5153) = -sqrt(2d0)*cima/2d0
    coupl(nGC_5173) = sqrt(2d0)/2d0
    coupl(nGC_5333) = -sqrt(2d0)*CZdR2x2*cima*ee*kZR/(cw*sw**2d0)
    coupl(nGC_5332) = -sqrt(2d0)*CZdR2x2*cima*ee*kZR/(cw**2d0*sw)
    coupl(nGC_5330) = -sqrt(2d0)*CZdL2x2*cima*ee*kZL/(cw*sw**2d0)
    coupl(nGC_5336) = -sqrt(2d0)*cima*ee*kZR*(CZdR2x3 + CZdR3x2)/(2d0*cw*sw**  &
                      2d0)
    coupl(nGC_5233) = -4d0*cima*cw*ee**2d0/sw**2d0
    coupl(nGC_5339) = -sqrt(2d0)*cima*ee*kZL*(CZdL2x3 + CZdL3x2)/(2d0*cw*sw**  &
                      2d0)
    coupl(nGC_5338) = -sqrt(2d0)*cima*ee*kZL*(CZdL2x3 + CZdL3x2)/(2d0*cw**2d0* &
                      sw)
    coupl(nGC_5236) = 2d0*cima*cw*ee**2d0/sw**2d0
    coupl(nGC_5234) = 4d0*cima*cw**2d0*ee**2d0/sw**3d0
    coupl(nGC_5176) = -sqrt(2d0)*cima/2d0
    coupl(nGC_5179) = -ee**2d0/(2d0*sw**2d0)
    coupl(nGC_5297) = -sqrt(2d0)*CWlR2x3*cima*ee*kWR/(2d0*sw**2d0)
    coupl(nGC_16) = cMW*cima*ee
    coupl(nGC_14) = -cima*lam
    coupl(nGC_13) = -cima*lam/2d0
    coupl(nGC_11) = cima*gs
    coupl(nGC_10) = -gs
    coupl(nGC_5243) = -sqrt(2d0)*CWqL1x2*cima*ee*kWL/(2d0*sw**2d0)
    coupl(nGC_19) = sqrt(2d0)*CZdL2x3*cima*ee*kZL/(2d0*cw*sw) + sqrt(2d0)*     &
                    CZdL3x2*cima*ee*kZL/(2d0*cw*sw)
    coupl(nGC_18) = sqrt(2d0)*CZdL1x3*cima*ee*kZL/(2d0*cw*sw) + sqrt(2d0)*     &
                    CZdL3x1*cima*ee*kZL/(2d0*cw*sw)
    coupl(nGC_5241) = -sqrt(2d0)*CWqL1x1*cima*ee*kWL/(2d0*sw**2d0)
    coupl(nGC_MW_GF) = cMW*cima
    coupl(nGC_5247) = -sqrt(2d0)*CWqL1x3*cima*ee*kWL/(2d0*sw**2d0)
    coupl(nGC_5245) = -sqrt(2d0)*CWqR1x2*cima*ee*kWR/(2d0*sw**2d0)
    coupl(nGC_417) = -coupl(nGC_10)
    coupl(nGC_97) = sqrt(2d0)*CZdR3x3*cima*ee*kZR/(cw*sw)
    coupl(nGC_5413) = -sqrt(2d0)*CZuL3x3*cima*ee*kZL/(cw**2d0*sw)
    coupl(nGC_5410) = -sqrt(2d0)*cima*ee*kZR*(CZuR2x3 + CZuR3x2)/(2d0*cw**2d0* &
                      sw)
    coupl(nGC_5411) = -sqrt(2d0)*cima*ee*kZR*(CZuR2x3 + CZuR3x2)/(2d0*cw*sw**  &
                      2d0)
    coupl(nGC_5416) = -sqrt(2d0)*CZuR3x3*cima*ee*kZR/(cw**2d0*sw)
    coupl(nGC_5414) = -sqrt(2d0)*CZuL3x3*cima*ee*kZL/(cw*sw**2d0)
    coupl(nGC_5378) = -sqrt(2d0)*CZlL3x3*cima*ee*kZL/(cw*sw**2d0)
    coupl(nGC_135) = -cima*sb*yc
    coupl(nGC_134) = cb*cima*yc
    coupl(nGC_133) = sqrt(2d0)*yc/2d0
    coupl(nGC_132) = -sqrt(2d0)*cima*yc/2d0
    coupl(nGC_5375) = -sqrt(2d0)*cima*ee*kZR*(CZlR2x3 + CZlR3x2)/(2d0*cw*sw**  &
                      2d0)
    coupl(nGC_84) = sqrt(2d0)*CWqR3x2*cima*ee*kWR/(2d0*sw)
    coupl(nGC_5374) = -sqrt(2d0)*cima*ee*kZR*(CZlR2x3 + CZlR3x2)/(2d0*cw**2d0* &
                      sw)
    coupl(nGC_5259) = -sqrt(2d0)*CWqR2x3*cima*ee*kWR/(2d0*sw**2d0)
  end subroutine fill_couplings_mdl1
end module fill_couplings1
