!******************************************************************************!
!                                                                              !
!    fill_couplings2.f90                                                       !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   fill_couplings2.f90                            |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 11/2018                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2020-07-30 18:24             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module fill_couplings2
  use constants_mdl
  use class_couplings
  use class_ctparameters
  implicit none
  contains
  subroutine fill_couplings_mdl2()
    coupl(nGC_5104) = -sqrt(2d0)*sb/2d0
    coupl(nGC_647) = -coupl(nGC_133)
    coupl(nGC_5052) = -3d0*cima*vev/2d0
    coupl(nGC_5053) = -3d0*cima*lam/2d0
    coupl(nGC_5050) = -cima*lam/2d0
    coupl(nGC_5058) = cima*ee/(2d0*cMW)
    coupl(nGC_5118) = sqrt(2d0)*sb/2d0
    coupl(nGC_5110) = sqrt(2d0)*cima*sb/2d0
    coupl(nGC_5115) = cb*cima
    coupl(nGC_5348) = -sqrt(2d0)*CZlR1x1*cima*ee*kZR/(cw*sw**2d0)
    coupl(nGC_103) = sqrt(2d0)*CZuR3x3*cima*ee*kZR/(cw*sw)
    coupl(nGC_5269) = -sqrt(2d0)*CWqL3x2*cima*ee*kWL/(2d0*sw**2d0)
    coupl(nGC_116) = -cima*cw*ee/(2d0*sw) + cima*ee*sw/(2d0*cw)
    coupl(nGC_5060) = -ee/(4d0*cMW*sw)
    coupl(nGC_5203) = cima*ee**2d0*(cw**2d0 + sw**2d0)/(cw*sw**2d0)
    coupl(nGC_5202) = -cima*ee**2d0*(cw**2d0 + sw**2d0)/(cw**2d0*sw)
    coupl(nGC_5200) = 2d0*cima*ee**2d0/sw**3d0
    coupl(nGC_5206) = ee*(cw - sw)*(cw + sw)/(2d0*cw*sw**2d0)
    coupl(nGC_5205) = -ee*(cw - sw)*(cw + sw)/(2d0*cw**2d0*sw)
    coupl(nGC_5209) = cima*ee*(cw**2d0 + sw**2d0)/(2d0*cw*sw**2d0)
    coupl(nGC_5208) = -cima*ee*(cw**2d0 + sw**2d0)/(2d0*cw**2d0*sw)
    coupl(nGC_5369) = -sqrt(2d0)*CZlR2x2*cima*ee*kZR/(cw*sw**2d0)
    coupl(nGC_5365) = -sqrt(2d0)*CZlL2x2*cima*ee*kZL/(cw**2d0*sw)
    coupl(nGC_5366) = -sqrt(2d0)*CZlL2x2*cima*ee*kZL/(cw*sw**2d0)
    coupl(nGC_5360) = -sqrt(2d0)*cima*ee*kZR*(CZlR1x3 + CZlR3x1)/(2d0*cw*sw**  &
                      2d0)
    coupl(nGC_5257) = -sqrt(2d0)*CWqL2x2*cima*ee*kWL/(2d0*sw**2d0)
    coupl(nGC_1739) = -coupl(nGC_116)
    coupl(nGC_119) = -cMW*cima*cw*ee/(2d0*sw) + cMW*cima*ee*sw/(2d0*cw)
    coupl(nGC_48) = ee**2d0/(2d0*sw)
    coupl(nGC_49) = 2d0*cima*cw*ee**2d0/sw
    coupl(nGC_44) = -cima*cw*ee/sw
    coupl(nGC_45) = cima*cw*ee/sw
    coupl(nGC_46) = -ee**2d0/(2d0*sw)
    coupl(nGC_47) = -cima*ee**2d0/(2d0*sw)
    coupl(nGC_40) = cima*ee/(2d0*sw)
    coupl(nGC_41) = ee/(2d0*sw)
    coupl(nGC_42) = sqrt(2d0)*cima*ee/(2d0*sw)
    coupl(nGC_43) = sqrt(2d0)*cb*cima*ee/(2d0*sw)
    coupl(nGC_5251) = -sqrt(2d0)*CWqL2x1*cima*ee*kWL/(2d0*sw**2d0)
    coupl(nGC_5095) = -sqrt(2d0)*cb/2d0
    coupl(nGC_5092) = cb*cima
    coupl(nGC_138) = -sqrt(2d0)*cb*cima*ydo/2d0
    coupl(nGC_5098) = -sqrt(2d0)*cb*cima/2d0
    coupl(nGC_141) = sqrt(2d0)*sb*ydo/2d0
    coupl(nGC_5380) = -sqrt(2d0)*CZlR3x3*cima*ee*kZR/(cw**2d0*sw)
    coupl(nGC_5368) = -sqrt(2d0)*CZlR2x2*cima*ee*kZR/(cw**2d0*sw)
    coupl(nGC_137) = -sqrt(2d0)*cb*ydo/2d0
    coupl(nGC_136) = -cima*ydo
    coupl(nGC_131) = -sqrt(2d0)*cima*yb/2d0
    coupl(nGC_5426) = sqrt(2d0)*cima*ee*sb/(2d0*sw**2d0)
    coupl(nGC_130) = -sqrt(2d0)*yb/2d0
    coupl(nGC_5267) = -sqrt(2d0)*CWqR3x2*cima*ee*kWR/(2d0*sw**2d0)
    coupl(nGC_2831) = 2d0*coupl(nGC_12)
    coupl(nGC_5184) = -cima*ee**2d0/(2d0*sw)
    coupl(nGC_5069) = -cima*ee*(cw - sw)*(cw + sw)/(4d0*cMW*cw*sw)
    coupl(nGC_5143) = -sqrt(2d0)*cima/2d0
    coupl(nGC_5063) = -cima*ee/(4d0*cMW*sw)
    coupl(nGC_139) = -sqrt(2d0)*sb*ydo/2d0
    coupl(nGC_5061) = cMW*ee/(2d0*sw**2d0)
    coupl(nGC_5066) = cima*ee/sw
    coupl(nGC_61) = sqrt(2d0)*CWqL1x3*cima*ee*kWL/(2d0*sw)
    coupl(nGC_5314) = -sqrt(2d0)*CZdL1x1*cima*ee*kZL/(cw**2d0*sw)
    coupl(nGC_144) = -sqrt(2d0)*cima*ye/2d0
    coupl(nGC_MD) = -cMD*cima
    coupl(nGC_5430) = cima*ee*(3d0*cw**2d0 + sw**2d0)/(6d0*cw**2d0*sw)
    coupl(nGC_5320) = -sqrt(2d0)*cima*ee*kZL*(CZdL1x2 + CZdL2x1)/(2d0*cw**2d0* &
                      sw)
    coupl(nGC_5321) = -sqrt(2d0)*cima*ee*kZL*(CZdL1x2 + CZdL2x1)/(2d0*cw*sw**  &
                      2d0)
    coupl(nGC_5323) = -sqrt(2d0)*cima*ee*kZL*(CZdL1x3 + CZdL3x1)/(2d0*cw**2d0* &
                      sw)
    coupl(nGC_5324) = -sqrt(2d0)*cima*ee*kZL*(CZdL1x3 + CZdL3x1)/(2d0*cw*sw**  &
                      2d0)
    coupl(nGC_5326) = -sqrt(2d0)*cima*ee*kZR*(CZdR1x3 + CZdR3x1)/(2d0*cw**2d0* &
                      sw)
    coupl(nGC_5327) = -sqrt(2d0)*cima*ee*kZR*(CZdR1x3 + CZdR3x1)/(2d0*cw*sw**  &
                      2d0)
    coupl(nGC_5329) = -sqrt(2d0)*CZdL2x2*cima*ee*kZL/(cw**2d0*sw)
    coupl(nGC_118) = -cima*cw*ee**2d0/sw + cima*ee**2d0*sw/cw
    coupl(nGC_5170) = -sqrt(2d0)*cima/2d0
    coupl(nGC_5151) = -sqrt(2d0)/2d0
    coupl(nGC_87) = sqrt(2d0)*CZdL2x2*cima*ee*kZL/(cw*sw)
    coupl(nGC_5141) = -sqrt(2d0)/2d0
    coupl(nGC_5396) = -sqrt(2d0)*cima*ee*kZR*(CZuR1x3 + CZuR3x1)/(2d0*cw*sw**  &
                      2d0)
    coupl(nGC_5393) = -sqrt(2d0)*cima*ee*kZR*(CZuR1x2 + CZuR2x1)/(2d0*cw*sw**  &
                      2d0)
    coupl(nGC_5392) = -sqrt(2d0)*cima*ee*kZR*(CZuR1x2 + CZuR2x1)/(2d0*cw**2d0* &
                      sw)
    coupl(nGC_5255) = -sqrt(2d0)*CWqR2x2*cima*ee*kWR/(2d0*sw**2d0)
    coupl(nGC_5399) = -sqrt(2d0)*cima*ee*kZL*(CZuL1x3 + CZuL3x1)/(2d0*cw*sw**  &
                      2d0)
    coupl(nGC_5398) = -sqrt(2d0)*cima*ee*kZL*(CZuL1x3 + CZuL3x1)/(2d0*cw**2d0* &
                      sw)
    coupl(nGC_99) = sqrt(2d0)*CZlR2x2*cima*ee*kZR/(cw*sw)
    coupl(nGC_95) = sqrt(2d0)*CZdR1x1*cima*ee*kZR/(cw*sw)
    coupl(nGC_90) = sqrt(2d0)*CZlL2x2*cima*ee*kZL/(cw*sw)
    coupl(nGC_5192) = cima*ee/(2d0*sw**2d0)
    coupl(nGC_5197) = cima*ee**2d0/(2d0*sw**2d0)
    coupl(nGC_5196) = -cima*ee**2d0*vev/sw**3d0
    coupl(nGC_5194) = -cima*ee**2d0/sw**3d0
    coupl(nGC_5067) = -cima*cw*ee/sw**2d0
    coupl(nGC_92) = sqrt(2d0)*CZuL1x1*cima*ee*kZL/(cw*sw)
    coupl(nGC_5071) = cMW*cima*ee*(cw**2d0 + sw**2d0)/(2d0*cw*sw**2d0)
    coupl(nGC_75) = sqrt(2d0)*CWlR3x2*cima*ee*kWR/(2d0*sw)
    coupl(nGC_74) = sqrt(2d0)*CWlR3x1*cima*ee*kWR/(2d0*sw)
    coupl(nGC_77) = sqrt(2d0)*CWqR1x1*cima*ee*kWR/(2d0*sw)
    coupl(nGC_76) = sqrt(2d0)*CWlR3x3*cima*ee*kWR/(2d0*sw)
    coupl(nGC_71) = sqrt(2d0)*CWlR2x1*cima*ee*kWR/(2d0*sw)
    coupl(nGC_73) = sqrt(2d0)*CWlR2x3*cima*ee*kWR/(2d0*sw)
    coupl(nGC_72) = sqrt(2d0)*CWlR2x2*cima*ee*kWR/(2d0*sw)
    coupl(nGC_5064) = cMW*cima*ee/(2d0*sw**2d0)
    coupl(nGC_79) = sqrt(2d0)*CWqR1x3*cima*ee*kWR/(2d0*sw)
    coupl(nGC_142) = -cima*ye
    coupl(nGC_104) = -cMW*ee/(2d0*sw)
    coupl(nGC_105) = -cMW*cima*ee/(2d0*sw)
    coupl(nGC_85) = sqrt(2d0)*CWqR3x3*cima*ee*kWR/(2d0*sw)
    coupl(nGC_86) = sqrt(2d0)*CZdL1x1*cima*ee*kZL/(cw*sw)
    coupl(nGC_17) = sqrt(2d0)*CZdL1x2*cima*ee*kZL/(2d0*cw*sw) + sqrt(2d0)*     &
                    CZdL2x1*cima*ee*kZL/(2d0*cw*sw)
    coupl(nGC_143) = -sqrt(2d0)*ye/2d0
    coupl(nGC_5342) = -sqrt(2d0)*CZdL3x3*cima*ee*kZL/(cw*sw**2d0)
    coupl(nGC_5363) = -sqrt(2d0)*cima*ee*kZL*(CZlL1x3 + CZlL3x1)/(2d0*cw*sw**  &
                      2d0)
    coupl(nGC_5417) = -sqrt(2d0)*CZuR3x3*cima*ee*kZR/(cw*sw**2d0)
    coupl(nGC_108) = -sqrt(2d0)*cima*ee*sb/(2d0*sw)
    coupl(nGC_183) = cima*gs
    coupl(nGC_5218) = ee**2d0/(2d0*cw**2d0)
    coupl(nGC_5249) = -sqrt(2d0)*CWqR1x3*cima*ee*kWR/(2d0*sw**2d0)
    coupl(nGC_5083) = -cima*ee*(cw**2d0 + sw**2d0)/(4d0*cMZ*cw*sw)
    coupl(nGC_5381) = -sqrt(2d0)*CZlR3x3*cima*ee*kZR/(cw*sw**2d0)
    coupl(nGC_5077) = -cMW*ee/(2d0*sw**2d0)
    coupl(nGC_5211) = -ee**2d0/(2d0*cw**2d0)
    coupl(nGC_5213) = cima*ee**2d0/(2d0*cw**2d0)
    coupl(nGC_5215) = cima*ee**2d0*vev/(2d0*cw**2d0)
    coupl(nGC_5216) = -cima*ee**2d0/(2d0*cw)
    coupl(nGC_82) = sqrt(2d0)*CWqR2x3*cima*ee*kWR/(2d0*sw)
    coupl(nGC_5359) = -sqrt(2d0)*cima*ee*kZR*(CZlR1x3 + CZlR3x1)/(2d0*cw**2d0* &
                      sw)
    coupl(nGC_5350) = -sqrt(2d0)*CZlL1x1*cima*ee*kZL/(cw**2d0*sw)
    coupl(nGC_5353) = -sqrt(2d0)*cima*ee*kZL*(CZlL1x2 + CZlL2x1)/(2d0*cw**2d0* &
                      sw)
    coupl(nGC_5354) = -sqrt(2d0)*cima*ee*kZL*(CZlL1x2 + CZlL2x1)/(2d0*cw*sw**  &
                      2d0)
    coupl(nGC_5357) = -sqrt(2d0)*cima*ee*kZR*(CZlR1x2 + CZlR2x1)/(2d0*cw*sw**  &
                      2d0)
    coupl(nGC_5351) = -sqrt(2d0)*CZlL1x1*cima*ee*kZL/(cw*sw**2d0)
    coupl(nGC_287) = -coupl(nGC_3)
    coupl(nGC_149) = -sqrt(2d0)*cb*ys/2d0
    coupl(nGC_5181) = cima*ee**2d0/(2d0*sw**2d0)
    coupl(nGC_661) = -coupl(nGC_130)
    coupl(nGC_94) = sqrt(2d0)*CZuL3x3*cima*ee*kZL/(cw*sw)
    coupl(nGC_39) = -cima*ee/(2d0*sw)
    coupl(nGC_38) = -2d0*cima*cw**2d0*ee**2d0/sw**2d0
    coupl(nGC_5183) = cima*ee**2d0*vev/(2d0*sw**2d0)
    coupl(nGC_31) = sqrt(2d0)*CZlR2x3*cima*ee*kZR/(2d0*cw*sw) + sqrt(2d0)*     &
                    CZlR3x2*cima*ee*kZR/(2d0*cw*sw)
    coupl(nGC_33) = sqrt(2d0)*CZuR1x3*cima*ee*kZR/(2d0*cw*sw) + sqrt(2d0)*     &
                    CZuR3x1*cima*ee*kZR/(2d0*cw*sw)
    coupl(nGC_5356) = -sqrt(2d0)*cima*ee*kZR*(CZlR1x2 + CZlR2x1)/(2d0*cw**2d0* &
                      sw)
    coupl(nGC_35) = cima*ee**2d0/(2d0*sw**2d0)
    coupl(nGC_34) = sqrt(2d0)*CZuR2x3*cima*ee*kZR/(2d0*cw*sw) + sqrt(2d0)*     &
                    CZuR3x2*cima*ee*kZR/(2d0*cw*sw)
    coupl(nGC_37) = cima*cw**2d0*ee**2d0/sw**2d0
    coupl(nGC_36) = -cima*ee**2d0/sw**2d0
    coupl(nGC_147) = -sqrt(2d0)*cima*ym/2d0
    coupl(nGC_5299) = -sqrt(2d0)*CWlR3x1*cima*ee*kWR/(2d0*sw**2d0)
    coupl(nGC_5265) = -sqrt(2d0)*CWqL3x1*cima*ee*kWL/(2d0*sw**2d0)
    coupl(nGC_5101) = -sqrt(2d0)*sb/2d0
    coupl(nGC_5428) = -sqrt(2d0)*cima*ee/(2d0*sw**2d0)
    coupl(nGC_5439) = -cima*ee*(3d0*cw**2d0 - sw**2d0)/(6d0*cw**2d0*sw)
    coupl(nGC_5434) = -2d0*cima*ee/(3d0*cw)
    coupl(nGC_5436) = -cima*ee*sw/(3d0*cw**2d0)
    coupl(nGC_5437) = cima*ee/(3d0*cw)
    coupl(nGC_MI) = -cima
    coupl(nGC_MH) = -cMH**2d0*cima
    coupl(nGC_MM) = -cMM*cima
    coupl(nGC_ME) = -cME*cima
    coupl(nGC_5315) = -sqrt(2d0)*CZdL1x1*cima*ee*kZL/(cw*sw**2d0)
    coupl(nGC_117) = cima*cw*ee/(2d0*sw) + cima*ee*sw/(2d0*cw)
    coupl(nGC_MS) = -cMS*cima
    coupl(nGC_2829) = -coupl(nGC_12)
    coupl(nGC_MW) = cMW**2d0*cima
    coupl(nGC_MU) = -cMU*cima
    coupl(nGC_MT) = -cMT*cima
    coupl(nGC_5079) = cima*ee/(4d0*cMZ*sw)
    coupl(nGC_5070) = -cMW*cima*ee*(cw**2d0 + sw**2d0)/(2d0*cw**2d0*sw)
    coupl(nGC_5073) = -cima*ee/sw
    coupl(nGC_5074) = cima*cw*ee/sw**2d0
    coupl(nGC_124) = -cima*lam*vev/2d0
    coupl(nGC_5076) = ee/(4d0*cMW*sw)
    coupl(nGC_145) = -cima*ym
    coupl(nGC_773) = -coupl(nGC_143)
    coupl(nGC_121) = cima*cw**2d0*ee**2d0/(2d0*sw**2d0) - cima*ee**2d0 + cima* &
                     ee**2d0*sw**2d0/(2d0*cw**2d0)
    coupl(nGC_5317) = -sqrt(2d0)*cima*ee*kZR*(CZdR1x2 + CZdR2x1)/(2d0*cw**2d0* &
                      sw)
    coupl(nGC_1273) = -coupl(nGC_156)
    coupl(nGC_5318) = -sqrt(2d0)*cima*ee*kZR*(CZdR1x2 + CZdR2x1)/(2d0*cw*sw**  &
                      2d0)
    coupl(nGC_321) = -coupl(nGC_161)
    coupl(nGC_114) = -cima*cw*ee/(2d0*sw) - cima*ee*sw/(6d0*cw)
    coupl(nGC_5431) = -cima*ee*(3d0*cw**2d0 + sw**2d0)/(6d0*cw*sw**2d0)
    coupl(nGC_5107) = -sqrt(2d0)*cima*sb/2d0
    coupl(nGC_112) = cima*ee*sw/cw
    coupl(nGC_5311) = -sqrt(2d0)*CZdR1x1*cima*ee*kZR/(cw**2d0*sw)
    coupl(nGC_MTA) = -cMTA*cima
    coupl(nGC_5291) = -sqrt(2d0)*CWlR2x2*cima*ee*kWR/(2d0*sw**2d0)
    coupl(nGC_5422) = -sqrt(2d0)*cb*cima*ee/(2d0*sw**2d0)
    coupl(nGC_5383) = -sqrt(2d0)*CZuR1x1*cima*ee*kZR/(cw**2d0*sw)
    coupl(nGC_32) = sqrt(2d0)*CZuR1x2*cima*ee*kZR/(2d0*cw*sw) + sqrt(2d0)*     &
                    CZuR2x1*cima*ee*kZR/(2d0*cw*sw)
    coupl(nGC_5386) = -sqrt(2d0)*CZuL1x1*cima*ee*kZL/(cw**2d0*sw)
    coupl(nGC_5387) = -sqrt(2d0)*CZuL1x1*cima*ee*kZL/(cw*sw**2d0)
    coupl(nGC_5146) = -sqrt(2d0)/2d0
    coupl(nGC_88) = sqrt(2d0)*CZdL3x3*cima*ee*kZL/(cw*sw)
    coupl(nGC_80) = sqrt(2d0)*CWqR2x1*cima*ee*kWR/(2d0*sw)
    coupl(nGC_81) = sqrt(2d0)*CWqR2x2*cima*ee*kWR/(2d0*sw)
    coupl(nGC_435) = -coupl(nGC_40)
    coupl(nGC_5283) = -sqrt(2d0)*CWlL1x3*cima*ee*kWL/(2d0*sw**2d0)
    coupl(nGC_5082) = -cMZ*cima*ee*(cw - sw)*(cw + sw)/(2d0*cw**2d0*sw)
    coupl(nGC_5186) = -ee/(2d0*sw**2d0)
    coupl(nGC_5188) = -cima*ee/(2d0*sw**2d0)
    coupl(nGC_146) = -sqrt(2d0)*ym/2d0
  end subroutine fill_couplings_mdl2
end module fill_couplings2
