!******************************************************************************!
!                                                                              !
!    fill_ctcouplings12.f90                                                    !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   fill_ctcouplings12.f90                         |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 11/2018                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2020-07-30 18:24             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module fill_ctcouplings12
  use constants_mdl
  use class_couplings
  use class_ctparameters
  implicit none
  contains
  subroutine fill_CTcouplings_mdl12()
    coupl(nGC_5364) = coupl(nGC_5362)*dcw_ + coupl(nGC_5363)*dsw_
    coupl(nGC_5361) = coupl(nGC_5359)*dcw_ + coupl(nGC_5360)*dsw_
    coupl(nGC_9003) = coupl(nGC_MD)*(dZdL_QCD2 + dZdR_QCD2)/2d0
    coupl(nGC_9002) = coupl(nGC_MI)*dZdL_QCD2
    coupl(nGC_8925) = coupl(nGC_114)*dZbL_QCD2
    coupl(nGC_8021) = coupl(nGC_147)*dZH/2d0 + coupl(nGC_5149)
    coupl(nGC_8022) = coupl(nGC_8018) + coupl(nGC_8021)
    coupl(nGC_8027) = coupl(nGC_40)*dZH/2d0 + coupl(nGC_40)*dZWMinus/2d0 +     &
                      coupl(nGC_5189)
    coupl(nGC_7669) = coupl(nGC_MI)*dZtL_QCD2
    coupl(nGC_4987) = coupl(nGC_11)*sq2*(coupl(nGC_23)**2d0 + coupl(nGC_24)**  &
                      2d0 + coupl(nGC_59)**2d0 + coupl(nGC_60)**2d0 + coupl(   &
                      nGC_61)**2d0 + coupl(nGC_92)**2d0)/(16d0*pi**2d0)
    coupl(nGC_4986) = coupl(nGC_11)*sq2*(4d0*coupl(nGC_109)**2d0 + 4d0*coupl(  &
                      nGC_115)**2d0 + coupl(nGC_136)**2d0 + coupl(nGC_160)**2d0&
                       + coupl(nGC_161)*coupl(nGC_321) + 4d0*coupl(nGC_2)**2d0 &
                       + 4d0*coupl(nGC_43)**2d0)/(64d0*pi**2d0)
    coupl(nGC_7661) = coupl(nGC_34)*dZZp/2d0 + coupl(nGC_5412)
    coupl(nGC_7660) = coupl(nGC_25)*dZZp/2d0 + coupl(nGC_5409)
    coupl(nGC_4983) = coupl(nGC_11)*sq2*(-coupl(nGC_23)**2d0 - coupl(nGC_24)** &
                      2d0 - coupl(nGC_59)**2d0 - coupl(nGC_60)**2d0 - coupl(   &
                      nGC_61)**2d0 - coupl(nGC_92)**2d0)/(16d0*pi**2d0*Nc)
    coupl(nGC_4982) = coupl(nGC_11)*sq2*(-4d0*coupl(nGC_109)**2d0 - 4d0*coupl( &
                      nGC_115)**2d0 - coupl(nGC_136)**2d0 - coupl(nGC_160)**2d0&
                       - coupl(nGC_161)*coupl(nGC_321) - 4d0*coupl(nGC_2)**2d0 &
                       - 4d0*coupl(nGC_43)**2d0)/(64d0*pi**2d0*Nc)
    coupl(nGC_4980) = coupl(nGC_11)*sq2*(4d0*coupl(nGC_1)**2d0 + 4d0*coupl(    &
                      nGC_110)**2d0 + coupl(nGC_148)**2d0 + coupl(nGC_149)*    &
                      coupl(nGC_767) + coupl(nGC_150)**2d0 + coupl(nGC_151)*   &
                      coupl(nGC_153) + coupl(nGC_152)**2d0)/(64d0*pi**2d0)
    coupl(nGC_8157) = coupl(nGC_24)*dZZp/2d0 + coupl(nGC_5400)
    coupl(nGC_8151) = coupl(nGC_33)*(dZtR_QCD2 + dZuR_QCD2)/2d0
    coupl(nGC_4860) = coupl(nGC_11)**2d0*coupl(nGC_661)*sq2**2d0*(Nc**2d0 - 1d0&
                      )/(16d0*pi**2d0*Nc)
    coupl(nGC_4861) = coupl(nGC_11)**2d0*coupl(nGC_130)*sq2**2d0*(Nc**2d0 - 1d0&
                      )/(16d0*pi**2d0*Nc)
    coupl(nGC_5292) = coupl(nGC_5291)*dsw_
    coupl(nGC_5294) = coupl(nGC_5293)*dsw_
    coupl(nGC_4865) = coupl(nGC_11)**2d0*coupl(nGC_137)*sq2**2d0*(Nc**2d0 - 1d0&
                      )/(16d0*pi**2d0*Nc)
    coupl(nGC_4866) = coupl(nGC_11)**2d0*coupl(nGC_141)*sq2**2d0*(Nc**2d0 - 1d0&
                      )/(16d0*pi**2d0*Nc)
    coupl(nGC_5096) = coupl(nGC_5095)*dydo_QED1
    coupl(nGC_5097) = coupl(nGC_5095)*dydo_QED1_QCD2
    coupl(nGC_5094) = coupl(nGC_5092)*dyup_QED1_QCD2
    coupl(nGC_7520) = coupl(nGC_5214) + coupl(nGC_8)*dZH/2d0 + coupl(nGC_8)*   &
                      dZWMinus/2d0 + coupl(nGC_8)*dZZ/2d0
    coupl(nGC_7523) = coupl(nGC_124)*dZH/2d0 + coupl(nGC_5051)
    coupl(nGC_5429) = coupl(nGC_5428)*dsw_
    coupl(nGC_4948) = coupl(nGC_11)*sq2*(-4d0*coupl(nGC_108)**2d0 - 4d0*coupl( &
                      nGC_115)**2d0 - coupl(nGC_132)**2d0 - coupl(nGC_133)*    &
                      coupl(nGC_647) - coupl(nGC_148)**2d0 - 4d0*coupl(nGC_2)**&
                      2d0 - 4d0*coupl(nGC_43)**2d0)/(64d0*pi**2d0*Nc)
    coupl(nGC_4910) = coupl(nGC_11)**2d0*coupl(nGC_114)*sq2**2d0*(Nc**2d0 - 1d0&
                      )/(32d0*pi**2d0*Nc)
    coupl(nGC_4911) = coupl(nGC_11)**2d0*coupl(nGC_110)*sq2**2d0*(Nc**2d0 - 1d0&
                      )/(32d0*pi**2d0*Nc)
    coupl(nGC_4912) = coupl(nGC_11)**2d0*coupl(nGC_88)*sq2**2d0*(Nc**2d0 - 1d0 &
                      )/(32d0*pi**2d0*Nc)
    coupl(nGC_5423) = coupl(nGC_5422)*dsw_
    coupl(nGC_9677) = coupl(nGC_MI)*dZWpMinus
    coupl(nGC_5421) = coupl(nGC_183)*dZgs_QCD2
    coupl(nGC_9672) = coupl(nGC_116)*dZZ/2d0 + coupl(nGC_116)*dZeMinusL + coupl&
                      (nGC_5210)
    coupl(nGC_9671) = coupl(nGC_112)*dZZ/2d0 + coupl(nGC_112)*dZeMinusR + coupl&
                      (nGC_5447)
    coupl(nGC_7960) = -coupl(nGC_5152) - coupl(nGC_7959)
    coupl(nGC_7961) = coupl(nGC_5152) + coupl(nGC_7959)
    coupl(nGC_7967) = -coupl(nGC_5096)
    coupl(nGC_7968) = -coupl(nGC_5097) - coupl(nGC_7966)
    coupl(nGC_7969) = coupl(nGC_5097) + coupl(nGC_7966)
    coupl(nGC_4971) = coupl(nGC_11)*sq2*(4d0*coupl(nGC_111)**2d0 + coupl(      &
                      nGC_1273)*coupl(nGC_156) + coupl(nGC_154)**2d0 + coupl(  &
                      nGC_155)**2d0 + 4d0*coupl(nGC_2)**2d0)/(64d0*pi**2d0)
    coupl(nGC_8376) = coupl(nGC_148)*dZcL_QCD2/2d0 + coupl(nGC_148)*dZsR_QCD2/ &
                      2d0 + coupl(nGC_5114)
    coupl(nGC_8377) = coupl(nGC_134)*dZcR_QCD2/2d0 + coupl(nGC_134)*dZsL_QCD2/ &
                      2d0 + coupl(nGC_5117)
    coupl(nGC_4976) = coupl(nGC_11)*sq2*(-4d0*coupl(nGC_1)**2d0 - 4d0*coupl(   &
                      nGC_110)**2d0 - coupl(nGC_148)**2d0 - coupl(nGC_149)*    &
                      coupl(nGC_767) - coupl(nGC_150)**2d0 - coupl(nGC_151)*   &
                      coupl(nGC_153) - coupl(nGC_152)**2d0)/(64d0*pi**2d0*Nc)
    coupl(nGC_9246) = -coupl(nGC_9245)
    coupl(nGC_7595) = coupl(nGC_114)*dZZ/2d0 + coupl(nGC_5441)
  end subroutine fill_CTcouplings_mdl12
end module fill_ctcouplings12
