!******************************************************************************!
!                                                                              !
!    fill_ctcouplings16.f90                                                    !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   fill_ctcouplings16.f90                         |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 11/2018                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2020-07-30 18:24             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module fill_ctcouplings16
  use constants_mdl
  use class_couplings
  use class_ctparameters
  implicit none
  contains
  subroutine fill_CTcouplings_mdl16()
    coupl(nGC_5260) = coupl(nGC_5259)*dsw_
    coupl(nGC_5388) = coupl(nGC_5386)*dcw_ + coupl(nGC_5387)*dsw_
    coupl(nGC_4892) = coupl(nGC_11)**2d0*coupl(nGC_80)*sq2**2d0*(Nc**2d0 - 1d0 &
                      )/(32d0*pi**2d0*Nc)
    coupl(nGC_4895) = coupl(nGC_11)**2d0*coupl(nGC_82)*sq2**2d0*(Nc**2d0 - 1d0 &
                      )/(32d0*pi**2d0*Nc)
    coupl(nGC_4812) = cima*(-coupl(nGC_103)**2d0 - coupl(nGC_33)**2d0 - coupl( &
                      nGC_34)**2d0 - coupl(nGC_83)**2d0 - coupl(nGC_84)**2d0 - &
                      coupl(nGC_85)**2d0)/(16d0*pi**2d0)
    coupl(nGC_4897) = coupl(nGC_11)**2d0*coupl(nGC_63)*sq2**2d0*(Nc**2d0 - 1d0 &
                      )/(32d0*pi**2d0*Nc)
    coupl(nGC_5266) = coupl(nGC_5265)*dsw_
    coupl(nGC_8048) = coupl(nGC_35)*dZH + coupl(nGC_35)*dZWMinus + coupl(      &
                      nGC_5195)
    coupl(nGC_8045) = coupl(nGC_127)*dZA/2d0 + coupl(nGC_127)*dZWMinus/2d0 +   &
                      coupl(nGC_5185)
    coupl(nGC_5187) = coupl(nGC_5186)*dsw_
    coupl(nGC_9302) = coupl(nGC_5316) + coupl(nGC_86)*dZZp/2d0
    coupl(nGC_9303) = coupl(nGC_5313) + coupl(nGC_95)*dZZp/2d0
    coupl(nGC_7601) = coupl(nGC_4)*dZtauMinusR
    coupl(nGC_4951) = coupl(nGC_11)*sq2*(-coupl(nGC_102)**2d0 - coupl(nGC_32)**&
                      2d0 - coupl(nGC_34)**2d0 - coupl(nGC_80)**2d0 - coupl(   &
                      nGC_81)**2d0 - coupl(nGC_82)**2d0)/(16d0*pi**2d0*Nc)
    coupl(nGC_7603) = coupl(nGC_7600) + coupl(nGC_7601)
    coupl(nGC_4966) = coupl(nGC_11)*sq2*(-4d0*coupl(nGC_111)**2d0 - coupl(     &
                      nGC_1273)*coupl(nGC_156) - coupl(nGC_154)**2d0 - coupl(  &
                      nGC_155)**2d0 - 4d0*coupl(nGC_2)**2d0)/(64d0*pi**2d0*Nc)
    coupl(nGC_9232) = coupl(nGC_100)*dZZp/2d0 + coupl(nGC_100)*dZtauMinusR +   &
                      coupl(nGC_5382)
    coupl(nGC_4960) = coupl(nGC_11)*sq2*(4d0*coupl(nGC_1)**2d0 + 4d0*coupl(    &
                      nGC_108)**2d0 + 4d0*coupl(nGC_114)**2d0 + coupl(nGC_135  &
                      )**2d0 + coupl(nGC_1351)*coupl(nGC_137) + coupl(nGC_138  &
                      )**2d0 + coupl(nGC_151)*coupl(nGC_153) + coupl(nGC_152)**&
                      2d0 + coupl(nGC_162)**2d0 + 4d0*coupl(nGC_43)**2d0)/(64d0&
                      *pi**2d0)
    coupl(nGC_9231) = coupl(nGC_5379) + coupl(nGC_91)*dZZp/2d0 + coupl(nGC_91)*&
                      dZtauMinusL
    coupl(nGC_4969) = coupl(nGC_11)*sq2*(4d0*coupl(nGC_115)**2d0 + coupl(      &
                      nGC_1273)*coupl(nGC_156) + coupl(nGC_129)**2d0 + coupl(  &
                      nGC_155)**2d0 + 4d0*coupl(nGC_2)**2d0 + 4d0*coupl(nGC_42 &
                      )**2d0)/(64d0*pi**2d0)
    coupl(nGC_8358) = coupl(nGC_110)*dZdR_QCD2
    coupl(nGC_7670) = coupl(nGC_MT)*(dZtL_QCD2 + dZtR_QCD2)/2d0
    coupl(nGC_4809) = cima*(-coupl(nGC_115)**2d0 - coupl(nGC_2)**2d0 - coupl(  &
                      nGC_42)**2d0)/(16d0*pi**2d0)
    coupl(nGC_4805) = cMT*cima*(-coupl(nGC_111)*coupl(nGC_115) - coupl(nGC_2)**&
                      2d0)/(8d0*pi**2d0)
    coupl(nGC_8587) = coupl(nGC_32)*dZZp/2d0 + coupl(nGC_5394)
    coupl(nGC_9295) = coupl(nGC_5464) + coupl(nGC_MW_GF)*dZWMinus/2d0
    coupl(nGC_7538) = coupl(nGC_120)*dZH/2d0 + coupl(nGC_5085)
    coupl(nGC_9398) = coupl(nGC_45)*dZWMinus + coupl(nGC_45)*dZZ/2d0 + coupl(  &
                      nGC_5068)
    coupl(nGC_7534) = coupl(nGC_5266) + coupl(nGC_65)*dZWpMinus/2d0
    coupl(nGC_8950) = coupl(nGC_5306) + coupl(nGC_75)*dZWpMinus/2d0 + coupl(   &
                      nGC_75)*dZmuMinusR/2d0 + coupl(nGC_75)*dZnu_tauR/2d0
    coupl(nGC_7776) = coupl(nGC_115)*dZZ/2d0 + coupl(nGC_5432)
    coupl(nGC_7874) = coupl(nGC_5388) + coupl(nGC_92)*dZZp/2d0
    coupl(nGC_7546) = coupl(nGC_19)*dZZp/2d0 + coupl(nGC_5340)
    coupl(nGC_7545) = coupl(nGC_28)*dZZp/2d0 + coupl(nGC_5337)
    coupl(nGC_8187) = 2d0*coupl(nGC_8185)
    coupl(nGC_7571) = coupl(nGC_5126) + coupl(nGC_7566)
    coupl(nGC_7742) = coupl(nGC_44)*dZWMinus/2d0 + coupl(nGC_5075)
    coupl(nGC_7570) = -coupl(nGC_5126) - coupl(nGC_7566)
    coupl(nGC_8227) = coupl(nGC_41)*dZWMinus/2d0 + coupl(nGC_5187)
    coupl(nGC_7549) = 2d0*coupl(nGC_36)*dZWMinus + coupl(nGC_5201)
    coupl(nGC_8028) = -coupl(nGC_8027)
    coupl(nGC_4998) = cima*coupl(nGC_11)**2d0*sq2**2d0*(-coupl(nGC_1273)*coupl(&
                      nGC_156) - coupl(nGC_130)*coupl(nGC_661) - coupl(nGC_133 &
                      )*coupl(nGC_647) - coupl(nGC_1351)*coupl(nGC_137) - coupl&
                      (nGC_139)*coupl(nGC_141) - coupl(nGC_149)*coupl(nGC_767  &
                      ) - coupl(nGC_151)*coupl(nGC_153) - coupl(nGC_161)*coupl(&
                      nGC_321))/(16d0*pi**2d0)
    coupl(nGC_11069) = -coupl(nGC_11065)
    coupl(nGC_9635) = -coupl(nGC_9398)
    coupl(nGC_7564) = coupl(nGC_7562) + coupl(nGC_7563)
    coupl(nGC_4978) = coupl(nGC_11)*sq2*(4d0*coupl(nGC_1)**2d0 + 4d0*coupl(    &
                      nGC_109)**2d0 + 4d0*coupl(nGC_114)**2d0 + coupl(nGC_134  &
                      )**2d0 + coupl(nGC_139)*coupl(nGC_141) + coupl(nGC_140)**&
                      2d0 + coupl(nGC_149)*coupl(nGC_767) + coupl(nGC_150)**2d0&
                       + coupl(nGC_163)**2d0 + 4d0*coupl(nGC_43)**2d0)/(64d0*pi&
                      **2d0)
    coupl(nGC_9006) = coupl(nGC_5457) + coupl(nGC_9003)
    coupl(nGC_9431) = coupl(nGC_151)*dZdL_QCD2/2d0 + coupl(nGC_151)*dZsR_QCD2/ &
                      2d0 + coupl(nGC_5103)
    coupl(nGC_8539) = coupl(nGC_5258) + coupl(nGC_63)*dZWpMinus/2d0
    coupl(nGC_4958) = coupl(nGC_11)*sq2*(-4d0*coupl(nGC_1)**2d0 - 4d0*coupl(   &
                      nGC_110)**2d0 - coupl(nGC_1351)*coupl(nGC_137) - coupl(  &
                      nGC_136)**2d0 - coupl(nGC_138)**2d0 - coupl(nGC_139)*    &
                      coupl(nGC_141) - coupl(nGC_140)**2d0)/(64d0*pi**2d0*Nc)
  end subroutine fill_CTcouplings_mdl16
end module fill_ctcouplings16
