!******************************************************************************!
!                                                                              !
!    fill_ctcouplings2.f90                                                     !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   fill_ctcouplings2.f90                          |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 11/2018                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2020-07-30 18:24             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module fill_ctcouplings2
  use constants_mdl
  use class_couplings
  use class_ctparameters
  implicit none
  contains
  subroutine fill_CTcouplings_mdl2()
    coupl(nGC_5415) = coupl(nGC_5413)*dcw_ + coupl(nGC_5414)*dsw_
    coupl(nGC_7629) = coupl(nGC_27)*(dZbR_QCD2 + dZdR_QCD2)/2d0
    coupl(nGC_4826) = cMS*cima*coupl(nGC_11)**2d0*sq2**2d0*(-Nc**2d0 + 1d0)/(  &
                      32d0*pi**2d0*Nc)
    coupl(nGC_4820) = cMB*cima*coupl(nGC_11)**2d0*sq2**2d0*(-Nc**2d0 + 1d0)/(  &
                      32d0*pi**2d0*Nc)
    coupl(nGC_4940) = -coupl(nGC_11)**2d0*sq2**3d0*(-Nc**2d0*cima*coupl(nGC_10 &
                      ) - coupl(nGC_11))/(64d0*pi**2d0*Nc**2d0)
    coupl(nGC_4945) = -coupl(nGC_11)**2d0*sq2**3d0*(Nc**2d0*cima*coupl(nGC_10  &
                      ) + coupl(nGC_11))/(64d0*pi**2d0*Nc)
    coupl(nGC_5051) = coupl(nGC_5049)*dlam_QED2 + coupl(nGC_5050)*dvev_QEDM1
    coupl(nGC_5054) = coupl(nGC_5052)*dlam_QED2 + coupl(nGC_5053)*dvev_QEDM1
    coupl(nGC_5059) = coupl(nGC_5058)*dMW2
    coupl(nGC_5463) = cima*dMWp2
    coupl(nGC_5461) = cima*dMZp2
    coupl(nGC_5460) = cima*dMZ2
    coupl(nGC_5349) = coupl(nGC_5347)*dcw_ + coupl(nGC_5348)*dsw_
    coupl(nGC_8861) = coupl(nGC_133)*(dZcL_QCD2 + dZcR_QCD2)/2d0
    coupl(nGC_7928) = coupl(nGC_5)*(dZA + dZWMinus)
    coupl(nGC_7929) = -2d0*coupl(nGC_7928)
    coupl(nGC_7924) = coupl(nGC_4)*dZWMinus/2d0
    coupl(nGC_7925) = -coupl(nGC_7924)
    coupl(nGC_223) = -cima/(2d0*cMW)
    coupl(nGC_227) = 1d0/(2d0*cMZ)
    coupl(nGC_8334) = coupl(nGC_11)*dZdL_QCD2
    coupl(nGC_8335) = coupl(nGC_11)*dZdR_QCD2
    coupl(nGC_7694) = coupl(nGC_11)*dZbL_QCD2
    coupl(nGC_7695) = coupl(nGC_11)*dZbR_QCD2
    coupl(nGC_5204) = coupl(nGC_5202)*dcw_ + coupl(nGC_5203)*dsw_
    coupl(nGC_4917) = coupl(nGC_11)**2d0*coupl(nGC_28)*sq2**2d0*(Nc**2d0 - 1d0 &
                      )/(32d0*pi**2d0*Nc)
    coupl(nGC_5160) = coupl(nGC_5158)*dyup_QED1_QCD2
    coupl(nGC_12323) = 3d0*coupl(nGC_125)*dZH/2d0 + coupl(nGC_5054)
    coupl(nGC_7626) = coupl(nGC_18)*(dZbL_QCD2 + dZdL_QCD2)/2d0
    coupl(nGC_4850) = coupl(nGC_11)**2d0*coupl(nGC_2)*sq2**2d0*(Nc**2d0 - 1d0  &
                      )/(32d0*pi**2d0*Nc)
    coupl(nGC_7624) = coupl(nGC_1)*dZbL_QCD2
    coupl(nGC_7747) = coupl(nGC_59)*(dZdL_QCD2 + dZuL_QCD2)/2d0
    coupl(nGC_8154) = coupl(nGC_24)*(dZtL_QCD2 + dZuL_QCD2)/2d0
    coupl(nGC_4869) = coupl(nGC_11)**2d0*coupl(nGC_151)*sq2**2d0*(Nc**2d0 - 1d0&
                      )/(16d0*pi**2d0*Nc)
    coupl(nGC_4863) = coupl(nGC_11)**2d0*coupl(nGC_133)*sq2**2d0*(Nc**2d0 - 1d0&
                      )/(16d0*pi**2d0*Nc)
    coupl(nGC_4867) = coupl(nGC_11)**2d0*coupl(nGC_153)*sq2**2d0*(Nc**2d0 - 1d0&
                      )/(16d0*pi**2d0*Nc)
    coupl(nGC_5093) = coupl(nGC_5092)*dyup_QED1
    coupl(nGC_5090) = -cima*dydo_QED1
    coupl(nGC_9217) = coupl(nGC_156)*(dZtL_QCD2 + dZtR_QCD2)/2d0
    coupl(nGC_4852) = coupl(nGC_11)**2d0*coupl(nGC_154)*sq2**2d0*(Nc**2d0 - 1d0&
                      )/(16d0*pi**2d0*Nc)
    coupl(nGC_5099) = coupl(nGC_5098)*dydo_QED1
    coupl(nGC_7526) = coupl(nGC_49)*dZA/2d0 + coupl(nGC_49)*dZWMinus + coupl(  &
                      nGC_49)*dZZ/2d0 + coupl(nGC_5222)
    coupl(nGC_7527) = -coupl(nGC_7526)/2d0
    coupl(nGC_7529) = coupl(nGC_65)*(dZdL_QCD2 + dZtL_QCD2)/2d0
    coupl(nGC_7805) = coupl(nGC_132)*(dZcL_QCD2 + dZcR_QCD2)/2d0
    coupl(nGC_4914) = coupl(nGC_11)**2d0*coupl(nGC_18)*sq2**2d0*(Nc**2d0 - 1d0 &
                      )/(32d0*pi**2d0*Nc)
    coupl(nGC_4915) = coupl(nGC_11)**2d0*coupl(nGC_27)*sq2**2d0*(Nc**2d0 - 1d0 &
                      )/(32d0*pi**2d0*Nc)
    coupl(nGC_4916) = coupl(nGC_11)**2d0*coupl(nGC_19)*sq2**2d0*(Nc**2d0 - 1d0 &
                      )/(32d0*pi**2d0*Nc)
    coupl(nGC_4913) = coupl(nGC_11)**2d0*coupl(nGC_97)*sq2**2d0*(Nc**2d0 - 1d0 &
                      )/(32d0*pi**2d0*Nc)
    coupl(nGC_9958) = -coupl(nGC_7956)
  end subroutine fill_CTcouplings_mdl2
end module fill_ctcouplings2
