!******************************************************************************!
!                                                                              !
!    fill_ctcouplings7.f90                                                     !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   fill_ctcouplings7.f90                          |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 11/2018                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2020-07-30 18:24             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module fill_ctcouplings7
  use constants_mdl
  use class_couplings
  use class_ctparameters
  implicit none
  contains
  subroutine fill_CTcouplings_mdl7()
    coupl(nGC_7904) = coupl(nGC_17)*dZZp/2d0 + coupl(nGC_5322)
    coupl(nGC_7869) = coupl(nGC_92)*dZuL_QCD2
    coupl(nGC_7901) = coupl(nGC_17)*(dZdL_QCD2 + dZsL_QCD2)/2d0
    coupl(nGC_7909) = coupl(nGC_5219) + coupl(nGC_7)*dZWMinus/2d0 + coupl(nGC_7&
                      )*dZZ/2d0
    coupl(nGC_5001) = cima*coupl(nGC_11)**2d0*sq2**2d0*(-coupl(nGC_108)*coupl( &
                      nGC_62) - coupl(nGC_109)*coupl(nGC_60) - coupl(nGC_42)*  &
                      coupl(nGC_67) - coupl(nGC_43)*coupl(nGC_59) - coupl(     &
                      nGC_43)*coupl(nGC_63))/(96d0*pi**2d0*Nc)
    coupl(nGC_5000) = cima*coupl(nGC_11)**2d0*sq2**2d0*(coupl(nGC_108)*coupl(  &
                      nGC_62) + coupl(nGC_109)*coupl(nGC_60) + coupl(nGC_42)*  &
                      coupl(nGC_67) + coupl(nGC_43)*coupl(nGC_59) + coupl(     &
                      nGC_43)*coupl(nGC_63))/(96d0*pi**2d0)
    coupl(nGC_5003) = cima*coupl(nGC_11)**2d0*sq2**2d0*(-coupl(nGC_1)**2d0 -   &
                      coupl(nGC_2)**2d0)/(16d0*pi**2d0*Nc)
    coupl(nGC_5002) = cima*coupl(nGC_11)**2d0*sq2**2d0*(coupl(nGC_1)**2d0 +    &
                      coupl(nGC_2)**2d0)/(16d0*pi**2d0)
    coupl(nGC_5005) = cima*coupl(nGC_11)**2d0*sq2**2d0*(-coupl(nGC_1)*coupl(   &
                      nGC_86) - coupl(nGC_1)*coupl(nGC_87) - coupl(nGC_1)*coupl&
                      (nGC_88) - coupl(nGC_1)*coupl(nGC_95) - coupl(nGC_1)*    &
                      coupl(nGC_96) - coupl(nGC_1)*coupl(nGC_97) - coupl(      &
                      nGC_101)*coupl(nGC_2) - coupl(nGC_102)*coupl(nGC_2) -    &
                      coupl(nGC_103)*coupl(nGC_2) - coupl(nGC_2)*coupl(nGC_92  &
                      ) - coupl(nGC_2)*coupl(nGC_93) - coupl(nGC_2)*coupl(     &
                      nGC_94))/(96d0*pi**2d0*Nc)
    coupl(nGC_5004) = cima*coupl(nGC_11)**2d0*sq2**2d0*(coupl(nGC_1)*coupl(    &
                      nGC_86) + coupl(nGC_1)*coupl(nGC_87) + coupl(nGC_1)*coupl&
                      (nGC_88) + coupl(nGC_1)*coupl(nGC_95) + coupl(nGC_1)*    &
                      coupl(nGC_96) + coupl(nGC_1)*coupl(nGC_97) + coupl(      &
                      nGC_101)*coupl(nGC_2) + coupl(nGC_102)*coupl(nGC_2) +    &
                      coupl(nGC_103)*coupl(nGC_2) + coupl(nGC_2)*coupl(nGC_92  &
                      ) + coupl(nGC_2)*coupl(nGC_93) + coupl(nGC_2)*coupl(     &
                      nGC_94))/(96d0*pi**2d0)
    coupl(nGC_5007) = cima*coupl(nGC_11)**2d0*sq2**2d0*(-coupl(nGC_1)*coupl(   &
                      nGC_110) - coupl(nGC_1)*coupl(nGC_114) - coupl(nGC_111)* &
                      coupl(nGC_2) - coupl(nGC_115)*coupl(nGC_2))/(32d0*pi**2d0&
                      *Nc)
    coupl(nGC_5009) = cima*coupl(nGC_11)**3d0*sq2**3d0*(-coupl(nGC_1) - coupl( &
                      nGC_2))/(32d0*pi**2d0*Nc)
    coupl(nGC_5008) = cima*coupl(nGC_11)**3d0*sq2**3d0*(coupl(nGC_1) + coupl(  &
                      nGC_2))/(64d0*pi**2d0)
    coupl(nGC_8255) = coupl(nGC_142)*dZeMinusR/2d0 + coupl(nGC_142)*dZnu_eL/2d0&
                       + coupl(nGC_5140)
    coupl(nGC_5166) = coupl(nGC_5164)*dyc_QED1_QCD2
    coupl(nGC_5346) = coupl(nGC_5344)*dcw_ + coupl(nGC_5345)*dsw_
    coupl(nGC_5228) = coupl(nGC_5226)*dcw_ + coupl(nGC_5227)*dsw_
    coupl(nGC_5340) = coupl(nGC_5338)*dcw_ + coupl(nGC_5339)*dsw_
    coupl(nGC_5225) = coupl(nGC_5223)*dcw_ + coupl(nGC_5224)*dsw_
    coupl(nGC_8148) = coupl(nGC_MI)*dZmuMinusR
    coupl(nGC_8008) = coupl(nGC_43)*(dZcL_QCD2 + dZsL_QCD2)/2d0
    coupl(nGC_8053) = coupl(nGC_67)*(dZbL_QCD2 + dZtL_QCD2)/2d0
    coupl(nGC_8820) = coupl(nGC_93)*dZcL_QCD2
    coupl(nGC_8110) = coupl(nGC_121)*dZZ + coupl(nGC_5228)
    coupl(nGC_4842) = cima*(-coupl(nGC_17)**2d0 - coupl(nGC_18)**2d0 - coupl(  &
                      nGC_59)**2d0 - coupl(nGC_62)**2d0 - coupl(nGC_65)**2d0 - &
                      coupl(nGC_86)**2d0)/(16d0*pi**2d0)
    coupl(nGC_7886) = coupl(nGC_80)*(dZcR_QCD2 + dZdR_QCD2)/2d0
    coupl(nGC_4840) = cima*(-cMB*coupl(nGC_18)*coupl(nGC_27) - cMC*coupl(nGC_62&
                      )*coupl(nGC_80) - cMD*coupl(nGC_86)*coupl(nGC_95) - cMS* &
                      coupl(nGC_17)*coupl(nGC_26) - cMT*coupl(nGC_65)*coupl(   &
                      nGC_83) - cMU*coupl(nGC_59)*coupl(nGC_77))/(8d0*pi**2d0)
    coupl(nGC_4841) = cima*(-coupl(nGC_1)**2d0 - coupl(nGC_108)**2d0 - coupl(  &
                      nGC_114)**2d0 - coupl(nGC_43)**2d0)/(16d0*pi**2d0)
    coupl(nGC_4846) = cima*coupl(nGC_11)**2d0*sq2**2d0*(cMB**2d0 + cMC**2d0 +  &
                      cMD**2d0 + cMS**2d0 + cMT**2d0 + cMU**2d0)/(16d0*pi**2d0)
    coupl(nGC_4844) = cima*sq2**2d0*(Nc*coupl(nGC_10)**2d0 - 4d0*coupl(nGC_11  &
                      )**2d0)/(64d0*pi**2d0)
    coupl(nGC_4845) = -Nc*cima*coupl(nGC_10)**2d0*sq2**2d0/(96d0*pi**2d0)
    coupl(nGC_4975) = coupl(nGC_11)*sq2*(-coupl(nGC_17)**2d0 - coupl(nGC_19)** &
                      2d0 - coupl(nGC_60)**2d0 - coupl(nGC_63)**2d0 - coupl(   &
                      nGC_66)**2d0 - coupl(nGC_87)**2d0)/(16d0*pi**2d0*Nc)
    coupl(nGC_4849) = cima*coupl(nGC_11)**2d0*sq2**2d0*(-cMB**2d0 - cMC**2d0 - &
                      cMD**2d0 - cMS**2d0 - cMT**2d0 - cMU**2d0)/(16d0*pi**2d0*&
                      Nc)
    coupl(nGC_5331) = coupl(nGC_5329)*dcw_ + coupl(nGC_5330)*dsw_
    coupl(nGC_10312) = coupl(nGC_MI)*dZbR_QCD2
    coupl(nGC_9005) = coupl(nGC_MI)*dZdR_QCD2
    coupl(nGC_10310) = coupl(nGC_MI)*dZbL_QCD2
    coupl(nGC_8073) = coupl(nGC_6)*dZA
    coupl(nGC_8176) = coupl(nGC_4)*dZeMinusR
    coupl(nGC_8177) = coupl(nGC_7600) + coupl(nGC_8176)
    coupl(nGC_9076) = coupl(nGC_MS)*(dZsL_QCD2 + dZsR_QCD2)/2d0
    coupl(nGC_8175) = coupl(nGC_4)*dZeMinusL
    coupl(nGC_8173) = coupl(nGC_48)*dZA/2d0 + coupl(nGC_48)*dZWMinus/2d0 +     &
                      coupl(nGC_5180)
    coupl(nGC_9297) = coupl(nGC_86)*dZdL_QCD2
    coupl(nGC_5406) = coupl(nGC_5404)*dcw_ + coupl(nGC_5405)*dsw_
    coupl(nGC_5400) = coupl(nGC_5398)*dcw_ + coupl(nGC_5399)*dsw_
    coupl(nGC_5403) = coupl(nGC_5401)*dcw_ + coupl(nGC_5402)*dsw_
    coupl(nGC_5409) = coupl(nGC_5407)*dcw_ + coupl(nGC_5408)*dsw_
    coupl(nGC_4837) = cima*(-coupl(nGC_101)**2d0 - coupl(nGC_32)**2d0 - coupl( &
                      nGC_33)**2d0 - coupl(nGC_77)**2d0 - coupl(nGC_78)**2d0 - &
                      coupl(nGC_79)**2d0)/(16d0*pi**2d0)
    coupl(nGC_4836) = cima*(-coupl(nGC_23)**2d0 - coupl(nGC_24)**2d0 - coupl(  &
                      nGC_59)**2d0 - coupl(nGC_60)**2d0 - coupl(nGC_61)**2d0 - &
                      coupl(nGC_92)**2d0)/(16d0*pi**2d0)
  end subroutine fill_CTcouplings_mdl7
end module fill_ctcouplings7
