!******************************************************************************!
!                                                                              !
!    fill_ctcouplings9.f90                                                     !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   fill_ctcouplings9.f90                          |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 11/2018                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2020-07-30 18:24             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module fill_ctcouplings9
  use constants_mdl
  use class_couplings
  use class_ctparameters
  implicit none
  contains
  subroutine fill_CTcouplings_mdl9()
    coupl(nGC_4970) = coupl(nGC_11)*sq2*(coupl(nGC_24)**2d0 + coupl(nGC_25)**  &
                      2d0 + coupl(nGC_65)**2d0 + coupl(nGC_66)**2d0 + coupl(   &
                      nGC_67)**2d0 + coupl(nGC_94)**2d0)/(16d0*pi**2d0)
    coupl(nGC_7753) = coupl(nGC_5240) + coupl(nGC_77)*dZWpMinus/2d0
    coupl(nGC_4977) = coupl(nGC_11)*sq2*(-coupl(nGC_26)**2d0 - coupl(nGC_28)** &
                      2d0 - coupl(nGC_78)**2d0 - coupl(nGC_81)**2d0 - coupl(   &
                      nGC_84)**2d0 - coupl(nGC_96)**2d0)/(16d0*pi**2d0*Nc)
    coupl(nGC_7750) = coupl(nGC_77)*(dZdR_QCD2 + dZuR_QCD2)/2d0
    coupl(nGC_7616) = coupl(nGC_64)*(dZbL_QCD2 + dZcL_QCD2)/2d0
    coupl(nGC_4979) = coupl(nGC_11)*sq2*(coupl(nGC_17)**2d0 + coupl(nGC_19)**  &
                      2d0 + coupl(nGC_60)**2d0 + coupl(nGC_63)**2d0 + coupl(   &
                      nGC_66)**2d0 + coupl(nGC_87)**2d0)/(16d0*pi**2d0)
    coupl(nGC_7613) = coupl(nGC_82)*(dZbR_QCD2 + dZcR_QCD2)/2d0
    coupl(nGC_7610) = coupl(nGC_160)*dZH/2d0 + coupl(nGC_5162)
    coupl(nGC_7611) = coupl(nGC_5163) + coupl(nGC_7606)
    coupl(nGC_8147) = coupl(nGC_MM)*(dZmuMinusL + dZmuMinusR)/2d0
    coupl(nGC_8146) = coupl(nGC_MI)*dZmuMinusL
    coupl(nGC_5288) = coupl(nGC_5287)*dsw_
    coupl(nGC_4872) = coupl(nGC_11)**2d0*coupl(nGC_1273)*sq2**2d0*(Nc**2d0 -   &
                      1d0)/(16d0*pi**2d0*Nc)
    coupl(nGC_4871) = coupl(nGC_11)**2d0*coupl(nGC_149)*sq2**2d0*(Nc**2d0 - 1d0&
                      )/(16d0*pi**2d0*Nc)
    coupl(nGC_5286) = coupl(nGC_5285)*dsw_
    coupl(nGC_8149) = coupl(nGC_5452) + coupl(nGC_8147)
    coupl(nGC_4874) = coupl(nGC_11)**2d0*coupl(nGC_321)*sq2**2d0*(Nc**2d0 - 1d0&
                      )/(16d0*pi**2d0*Nc)
    coupl(nGC_5089) = coupl(nGC_5088)*dZgs_QCD2
    coupl(nGC_4950) = coupl(nGC_11)*sq2*(-4d0*coupl(nGC_111)**2d0 - coupl(     &
                      nGC_132)**2d0 - coupl(nGC_133)*coupl(nGC_647) - coupl(   &
                      nGC_134)**2d0 - coupl(nGC_135)**2d0 - 4d0*coupl(nGC_2)** &
                      2d0)/(64d0*pi**2d0*Nc)
    coupl(nGC_5120) = coupl(nGC_5118)*dys_QED1_QCD2
    coupl(nGC_5126) = coupl(nGC_5124)*dys_QED1_QCD2
    coupl(nGC_7535) = coupl(nGC_5264) + coupl(nGC_83)*dZWpMinus/2d0
    coupl(nGC_5081) = coupl(nGC_5079)*dMZ2 + coupl(nGC_5080)*dsw_
    coupl(nGC_5085) = coupl(nGC_5082)*dcw_ + coupl(nGC_5083)*dMZ2 + coupl(     &
                      nGC_5084)*dsw_
    coupl(nGC_5087) = coupl(nGC_5086)*dZgs_QCD2
    coupl(nGC_4989) = coupl(nGC_11)*sq2*(coupl(nGC_101)**2d0 + coupl(nGC_32)** &
                      2d0 + coupl(nGC_33)**2d0 + coupl(nGC_77)**2d0 + coupl(   &
                      nGC_78)**2d0 + coupl(nGC_79)**2d0)/(16d0*pi**2d0)
    coupl(nGC_5006) = cima*coupl(nGC_11)**2d0*sq2**2d0*(coupl(nGC_1)*coupl(    &
                      nGC_110) + coupl(nGC_1)*coupl(nGC_114) + coupl(nGC_111)* &
                      coupl(nGC_2) + coupl(nGC_115)*coupl(nGC_2))/(32d0*pi**2d0&
                      )
    coupl(nGC_4906) = coupl(nGC_11)**2d0*coupl(nGC_60)*sq2**2d0*(Nc**2d0 - 1d0 &
                      )/(32d0*pi**2d0*Nc)
    coupl(nGC_10084) = coupl(nGC_MU)*(dZuL_QCD2 + dZuR_QCD2)/2d0
    coupl(nGC_4903) = coupl(nGC_11)**2d0*coupl(nGC_83)*sq2**2d0*(Nc**2d0 - 1d0 &
                      )/(32d0*pi**2d0*Nc)
    coupl(nGC_10083) = coupl(nGC_MI)*dZuL_QCD2
    coupl(nGC_4985) = coupl(nGC_11)*sq2*(-coupl(nGC_101)**2d0 - coupl(nGC_32)**&
                      2d0 - coupl(nGC_33)**2d0 - coupl(nGC_77)**2d0 - coupl(   &
                      nGC_78)**2d0 - coupl(nGC_79)**2d0)/(16d0*pi**2d0*Nc)
    coupl(nGC_4909) = coupl(nGC_11)**2d0*coupl(nGC_111)*sq2**2d0*(Nc**2d0 - 1d0&
                      )/(32d0*pi**2d0*Nc)
    coupl(nGC_4908) = coupl(nGC_11)**2d0*coupl(nGC_115)*sq2**2d0*(Nc**2d0 - 1d0&
                      )/(32d0*pi**2d0*Nc)
    coupl(nGC_4984) = coupl(nGC_11)*sq2*(-4d0*coupl(nGC_111)**2d0 - coupl(     &
                      nGC_160)**2d0 - coupl(nGC_161)*coupl(nGC_321) - coupl(   &
                      nGC_162)**2d0 - coupl(nGC_163)**2d0 - 4d0*coupl(nGC_2)** &
                      2d0)/(64d0*pi**2d0*Nc)
    coupl(nGC_7977) = coupl(nGC_22)*dZZp/2d0 + coupl(nGC_22)*dZmuMinusL/2d0 +  &
                      coupl(nGC_22)*dZtauMinusL/2d0 + coupl(nGC_5373)
    coupl(nGC_7978) = coupl(nGC_31)*dZZp/2d0 + coupl(nGC_31)*dZmuMinusR/2d0 +  &
                      coupl(nGC_31)*dZtauMinusR/2d0 + coupl(nGC_5376)
    coupl(nGC_7875) = coupl(nGC_101)*dZZp/2d0 + coupl(nGC_5385)
    coupl(nGC_4981) = coupl(nGC_11)*sq2*(coupl(nGC_26)**2d0 + coupl(nGC_28)**  &
                      2d0 + coupl(nGC_78)**2d0 + coupl(nGC_81)**2d0 + coupl(   &
                      nGC_84)**2d0 + coupl(nGC_96)**2d0)/(16d0*pi**2d0)
    coupl(nGC_8369) = coupl(nGC_5349) + coupl(nGC_98)*dZZp/2d0 + coupl(nGC_98)*&
                      dZeMinusR
    coupl(nGC_8368) = coupl(nGC_5352) + coupl(nGC_89)*dZZp/2d0 + coupl(nGC_89)*&
                      dZeMinusL
    coupl(nGC_5157) = coupl(nGC_5155)*dyup_QED1_QCD2
    coupl(nGC_5156) = coupl(nGC_5155)*dyup_QED1
    coupl(nGC_5154) = coupl(nGC_5153)*dytau_QED1
    coupl(nGC_5152) = coupl(nGC_5151)*dytau_QED1
    coupl(nGC_5018) = cima*coupl(nGC_11)**3d0*sq2**3d0*(-coupl(nGC_110) - coupl&
                      (nGC_111) - coupl(nGC_114) - coupl(nGC_115))/(64d0*pi**  &
                      2d0*Nc)
    coupl(nGC_5019) = cima*coupl(nGC_11)**3d0*sq2**3d0*(coupl(nGC_110) + coupl(&
                      nGC_111) + coupl(nGC_114) + coupl(nGC_115))/(32d0*pi**2d0&
                      *Nc**2d0)
    coupl(nGC_5016) = cima*coupl(nGC_11)**2d0*sq2**2d0*(-coupl(nGC_59)**2d0 -  &
                      coupl(nGC_60)**2d0 - coupl(nGC_61)**2d0 - coupl(nGC_62)**&
                      2d0 - coupl(nGC_63)**2d0 - coupl(nGC_64)**2d0 - coupl(   &
                      nGC_65)**2d0 - coupl(nGC_66)**2d0 - coupl(nGC_67)**2d0 - &
                      coupl(nGC_77)**2d0 - coupl(nGC_78)**2d0 - coupl(nGC_79)**&
                      2d0 - coupl(nGC_80)**2d0 - coupl(nGC_81)**2d0 - coupl(   &
                      nGC_82)**2d0 - coupl(nGC_83)**2d0 - coupl(nGC_84)**2d0 - &
                      coupl(nGC_85)**2d0)/(96d0*pi**2d0*Nc)
    coupl(nGC_5017) = cima*coupl(nGC_11)**3d0*sq2**3d0*(coupl(nGC_110) + coupl(&
                      nGC_111) + coupl(nGC_114) + coupl(nGC_115))/(128d0*pi**  &
                      2d0)
    coupl(nGC_5014) = cima*coupl(nGC_11)**2d0*sq2**2d0*(-coupl(nGC_101)*coupl( &
                      nGC_111) - coupl(nGC_102)*coupl(nGC_111) - coupl(nGC_103 &
                      )*coupl(nGC_111) - coupl(nGC_110)*coupl(nGC_95) - coupl( &
                      nGC_110)*coupl(nGC_96) - coupl(nGC_110)*coupl(nGC_97) -  &
                      coupl(nGC_114)*coupl(nGC_86) - coupl(nGC_114)*coupl(     &
                      nGC_87) - coupl(nGC_114)*coupl(nGC_88) - coupl(nGC_115)* &
                      coupl(nGC_92) - coupl(nGC_115)*coupl(nGC_93) - coupl(    &
                      nGC_115)*coupl(nGC_94))/(96d0*pi**2d0*Nc)
  end subroutine fill_CTcouplings_mdl9
end module fill_ctcouplings9
