!******************************************************************************!
!                                                                              !
!    ctparameter45.f90                                                         !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   ctparameter45.f90                              |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 11/2018                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2020-07-30 18:24             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module ctparameter45
  use input_mdl, only: DeltaUV,muUV,muMS
  use class_ctparameters
  use modelintegrals
  use class_couplings
contains
subroutine set_ctparameter45()
  dMT_QCD2 = (pi**2d0*(-4d0*Nc*aS*cMT**2d0/(pi*rMT) + 4d0*Nc*aS*rMT/pi - Nc*cMT&
             *coupl(nGC_11)**2d0/(2d0*pi**2d0) + 4d0*aS*cMT**2d0/(pi*Nc*rMT) - &
             4d0*aS*rMT/(pi*Nc) + cMT*coupl(nGC_11)**2d0/(2d0*pi**2d0*Nc)) +   &
             Ten70*cMT*coupl(nGC_11)**2d0*(Nc**2d0 - 1d0)/Nc + Ten71*cMT*coupl(&
             nGC_11)**2d0*(-Nc**2d0 + 1d0)/Nc + 2d0*Ten72*coupl(nGC_11)**2d0*  &
             rMT*(2d0*Nc**2d0*cMT**2d0 - 3d0*Nc**2d0*cMT*rMT + Nc**2d0*rMT**2d0&
              - 2d0*cMT**2d0 + 3d0*cMT*rMT - rMT**2d0)/Nc + 2d0*Ten73*coupl(   &
             nGC_11)**2d0*rMT**2d0*(-Nc**2d0*cMT + Nc**2d0*rMT + cMT - rMT)/Nc &
             )/(16d0*pi**2d0)
    if (.not. complex_mass_scheme) then
      dMT_QCD2 = cone*real(dMT_QCD2,kind=dp)
    end if 
end subroutine set_ctparameter45
end module ctparameter45
