!******************************************************************************!
!                                                                              !
!    tcVVV.f90                                                                 !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcVVV.f90                                      |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 11/2018                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2020-07-30 18:23             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcVVV
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29
  contains
    subroutine treeVVV(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,   &
    VB_last)
      use class_vertices
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(VVV0)
!       c0*(Metric(1,2)*P(3,1) - Metric(1,2)*P(3,2) - Metric(1,3)*P(2,1) + Metric
!       (1,3)*P(2,3) + Metric(2,3)*P(1,2) - Metric(2,3)*P(1,3))
        if (last) VB_last = .true.
        x0 = -w1(0)*w2(0) + w1(1)*w2(1) + w1(2)*w2(2) + w1(3)*w2(3)
        wout = -co(0)*(P1(:)*x0 - P2(:)*x0 - w1(:)*(2*P1(1)*w2(1) + 2*P1(2)*w2(&
               2) + 2*P1(3)*w2(3) + P2(1)*w2(1) + P2(2)*w2(2) + P2(3)*w2(3) -  &
               w2(0)*(2*P1(0) + P2(0))) + w2(:)*(-w1(0)*(P1(0) + 2*P2(0)) + w1(&
               1)*(P1(1) + 2*P2(1)) + w1(2)*(P1(2) + 2*P2(2)) + w1(3)*(P1(3) + &
               2*P2(3))))
      case(VVV1)
!       c0*(Epsilon(-1,1,2,3)*P(-1,1) + Epsilon(-1,1,2,3)*P(-1,3)/2)
        if (last) VB_last = .true.
        x0 = w1(2)*w2(3)
        x1 = P1(2)*w1(3)
        x2 = P1(3)*w1(1)
        x3 = w1(3)*w2(2)
        x4 = P2(2)*w2(3)
        x5 = w1(2)*w2(1)
        x6 = P1(2)*w2(3)
        x7 = P2(2)*w1(3)
        x8 = w1(1)*w2(2)
        x9 = co(0)/2
        x10 = w1(0)*w2(2)
        x11 = w1(2)*w2(0)
        x12 = P2(1)*w1(0)
        x13 = P1(1)*w1(0)
        x14 = w1(3)*w2(1)
        x15 = w1(3)*w2(0)
        x16 = w1(0)*w2(1)
        x17 = w1(1)*w2(0)
        wout(0) = x9*(P1(1)*x0 - P1(1)*x3 - P1(3)*x5 - P2(1)*x0 + P2(1)*x3 + P2&
                  (3)*x5 - P2(3)*x8 + w1(1)*x4 - w1(1)*x6 + w2(1)*x1 - w2(1)*x7&
                   + w2(2)*x2)
        wout(1) = x9*(P1(0)*x0 - P1(0)*x3 + P1(3)*x10 - P1(3)*x11 - P2(0)*x0 + &
                  P2(0)*x3 - P2(3)*x10 + P2(3)*x11 + w1(0)*x4 - w1(0)*x6 + w2(0&
                  )*x1 - w2(0)*x7)
        wout(2) = x9*(P1(0)*x14 - P1(1)*x15 - P1(3)*x16 - P2(0)*x14 + P2(1)*x15&
                   + P2(3)*x16 - P2(3)*x17 + w2(0)*x2 - w2(3)*(w1(1)*(P1(0) -  &
                  P2(0)) + x12 - x13))
        wout(3) = x9*(-P1(0)*x5 + P1(0)*x8 + P1(1)*x11 + P1(2)*x16 - P1(2)*x17 &
                   + P2(0)*x5 - P2(0)*x8 - P2(1)*x11 - P2(2)*x16 + P2(2)*x17 + &
                  w2(2)*x12 - w2(2)*x13)
      case(VVV2)
!       c0*(-Epsilon(-1,1,2,3)*P(-1,1) - Epsilon(-1,1,2,3)*P(-1,2)/2)
        if (last) VB_last = .true.
        x0 = P2(2)*w1(1)
        x1 = 2*P1(1)
        x2 = 2*P1(2)
        x3 = w1(1)*x2
        x4 = w1(3)*w2(2)
        x5 = w1(2)*w2(1)
        x6 = w1(3)*w2(1)
        x7 = P2(3)*w1(1)
        x8 = 2*P1(3)*w1(1)
        x9 = 2*P1(3)
        x10 = co(0)/2
        x11 = P2(2)*w1(0)
        x12 = 2*P1(0)
        x13 = P2(0) + x12
        x14 = w1(0)*x2
        x15 = w1(2)*w2(0)
        x16 = w1(3)*w2(0)
        x17 = P2(3)*w1(0)
        x18 = 2*P1(3)*w1(0)
        x19 = w1(1)*w2(3)
        x20 = P2(1)*w1(0)
        x21 = w1(0)*x1
        wout(0) = x10*(P2(1)*x4 - P2(2)*x6 + P2(3)*x5 - w2(2)*x7 - w2(2)*x8 +  &
                  w2(3)*(-w1(2)*(P2(1) + x1) + x0 + x3) + x1*x4 - x2*x6 + x5*x9&
                  )
        wout(1) = x10*(P2(0)*x4 - P2(2)*x16 + P2(3)*x15 - w2(2)*x17 - w2(2)*x18&
                   + w2(3)*(-w1(2)*x13 + x11 + x14) + x12*x4 + x15*x9 - x16*x2)
        wout(2) = x10*(P2(0)*x19 - P2(0)*x6 + P2(1)*x16 - w2(0)*x7 - w2(0)*x8  &
                   + w2(1)*x17 + w2(1)*x18 - w2(3)*x20 - w2(3)*x21 + x1*x16 +  &
                  x12*x19 - x12*x6)
        wout(3) = x10*(P2(0)*x5 - P2(1)*x15 + w2(0)*x0 + w2(0)*x3 - w2(1)*x11  &
                   - w2(1)*x14 + w2(2)*(-w1(1)*x13 + x20 + x21) - x1*x15 + x12*&
                  x5)
      case(VVV3)
!       c0*(Epsilon(-1,1,2,3)*P(-1,1)/2 + Epsilon(-1,1,2,3)*P(-1,2))
        if (last) VB_last = .true.
        x0 = w1(2)*w2(3)
        x1 = P1(2)*w1(3)
        x2 = P1(3)*w1(1)
        x3 = P1(1)*w1(3)
        x4 = P1(2)*w2(3)
        x5 = P1(3)*w1(2)
        x6 = 2*P2(1)*w1(3)
        x7 = 2*P2(2)*w2(3)
        x8 = 2*P2(3)
        x9 = w1(2)*w2(1)
        x10 = 2*P2(1)
        x11 = 2*P2(2)*w1(3)
        x12 = co(0)/2
        x13 = w1(0)*w2(2)
        x14 = P1(0)*w2(2)
        x15 = 2*P2(0)*w2(2)
        x16 = w1(2)*w2(0)
        x17 = 2*P2(0)
        x18 = P1(1)*w1(0)
        x19 = w1(0)*x10
        x20 = P1(0)*w2(1)
        x21 = w1(0)*w2(1)
        x22 = w1(1)*w2(0)
        x23 = 2*P2(2)
        wout(0) = x12*(P1(1)*x0 + w1(1)*w2(2)*x8 - w1(1)*x4 - w1(1)*x7 + w2(1)*&
                  x1 + w2(1)*x11 - w2(1)*x5 + w2(2)*x2 - w2(2)*x3 - w2(2)*x6 + &
                  x0*x10 - x8*x9)
        wout(1) = x12*(P1(0)*x0 + P1(3)*x13 - w1(0)*x4 - w1(0)*x7 - w1(3)*x14  &
                   - w1(3)*x15 + w2(0)*x1 + w2(0)*x11 - w2(0)*x5 + x0*x17 + x13&
                  *x8 - x16*x8)
        wout(2) = x12*(-P1(3)*x21 + w1(3)*w2(1)*x17 + w1(3)*x20 + w2(0)*x2 - w2&
                  (0)*x3 - w2(0)*x6 + w2(3)*(-w1(1)*(P1(0) + x17) + x18 + x19  &
                  ) - x21*x8 + x22*x8)
        wout(3) = x12*(P1(1)*x16 + P1(2)*x21 - P1(2)*x22 + w1(1)*x14 + w1(1)*  &
                  x15 - w1(2)*x20 - w2(2)*x18 - w2(2)*x19 + x10*x16 - x17*x9 + &
                  x21*x23 - x22*x23)
      end select 
    end subroutine treeVVV
end module tcVVV
